/* ComposedTweet.c generated by valac 0.48.13, the Vala compiler
 * generated from ComposedTweet.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2020 IBBoard
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "CbTweet.h"
#include <gobject/gvaluecollector.h>

#define TYPE_COMPOSED_TWEET (composed_tweet_get_type ())
#define COMPOSED_TWEET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMPOSED_TWEET, ComposedTweet))
#define COMPOSED_TWEET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMPOSED_TWEET, ComposedTweetClass))
#define IS_COMPOSED_TWEET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMPOSED_TWEET))
#define IS_COMPOSED_TWEET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMPOSED_TWEET))
#define COMPOSED_TWEET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMPOSED_TWEET, ComposedTweetClass))

typedef struct _ComposedTweet ComposedTweet;
typedef struct _ComposedTweetClass ComposedTweetClass;
typedef struct _ComposedTweetPrivate ComposedTweetPrivate;

#define TYPE_MEDIA_UPLOAD (media_upload_get_type ())
#define MEDIA_UPLOAD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_UPLOAD, MediaUpload))
#define MEDIA_UPLOAD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_UPLOAD, MediaUploadClass))
#define IS_MEDIA_UPLOAD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_UPLOAD))
#define IS_MEDIA_UPLOAD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_UPLOAD))
#define MEDIA_UPLOAD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_UPLOAD, MediaUploadClass))

typedef struct _MediaUpload MediaUpload;
typedef struct _MediaUploadClass MediaUploadClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
typedef struct _ParamSpecComposedTweet ParamSpecComposedTweet;
enum  {
	COMPOSED_TWEET_READY_SIGNAL,
	COMPOSED_TWEET_NUM_SIGNALS
};
static guint composed_tweet_signals[COMPOSED_TWEET_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ComposedTweet {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ComposedTweetPrivate * priv;
};

struct _ComposedTweetClass {
	GTypeClass parent_class;
	void (*finalize) (ComposedTweet *self);
};

struct _ComposedTweetPrivate {
	gchar* _text;
	GPtrArray* _uploads;
	gint64 _reply_to_id;
	gchar* _quoted_tweet_url;
};

struct _ParamSpecComposedTweet {
	GParamSpec parent_instance;
};

static gint ComposedTweet_private_offset;
static gpointer composed_tweet_parent_class = NULL;

gpointer composed_tweet_ref (gpointer instance);
void composed_tweet_unref (gpointer instance);
GParamSpec* param_spec_composed_tweet (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_composed_tweet (GValue* value,
                               gpointer v_object);
void value_take_composed_tweet (GValue* value,
                                gpointer v_object);
gpointer value_get_composed_tweet (const GValue* value);
GType composed_tweet_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ComposedTweet, composed_tweet_unref)
GType media_upload_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaUpload, g_object_unref)
ComposedTweet* composed_tweet_new (const gchar* text);
ComposedTweet* composed_tweet_construct (GType object_type,
                                         const gchar* text);
static void _g_object_unref0_ (gpointer var);
void composed_tweet_add_attachment (ComposedTweet* self,
                                    MediaUpload* upload);
static void __lambda64_ (ComposedTweet* self,
                  GError* message);
static void ___lambda64__media_upload_progress_complete (MediaUpload* _sender,
                                                  GError* _error_,
                                                  gpointer self);
MediaUpload** composed_tweet_get_attachments (ComposedTweet* self,
                                              gint* result_length1);
static MediaUpload** _vala_array_dup8 (MediaUpload** self,
                                gint length);
gchar* composed_tweet_get_text (ComposedTweet* self);
gchar* composed_tweet_get_quoted_url (ComposedTweet* self);
gboolean composed_tweet_has_quote_attachment (ComposedTweet* self);
void composed_tweet_set_quoted_tweet (ComposedTweet* self,
                                      CbTweet* tweet);
gint64 composed_tweet_get_reply_to_id (ComposedTweet* self);
void composed_tweet_set_reply_to_id (ComposedTweet* self,
                                     gint64 value);
static void composed_tweet_finalize (ComposedTweet * obj);
static GType composed_tweet_get_type_once (void);

static inline gpointer
composed_tweet_get_instance_private (ComposedTweet* self)
{
	return G_STRUCT_MEMBER_P (self, ComposedTweet_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

ComposedTweet*
composed_tweet_construct (GType object_type,
                          const gchar* text)
{
	ComposedTweet* self = NULL;
	gchar* _tmp0_;
	GPtrArray* _tmp1_;
	g_return_val_if_fail (text != NULL, NULL);
	self = (ComposedTweet*) g_type_create_instance (object_type);
	_tmp0_ = g_strdup (text);
	_g_free0 (self->priv->_text);
	self->priv->_text = _tmp0_;
	_tmp1_ = g_ptr_array_new_full ((guint) 4, _g_object_unref0_);
	_g_ptr_array_unref0 (self->priv->_uploads);
	self->priv->_uploads = _tmp1_;
	return self;
}

ComposedTweet*
composed_tweet_new (const gchar* text)
{
	return composed_tweet_construct (TYPE_COMPOSED_TWEET, text);
}

static void
__lambda64_ (ComposedTweet* self,
             GError* message)
{
	if (message == NULL) {
		g_signal_emit (self, composed_tweet_signals[COMPOSED_TWEET_READY_SIGNAL], 0);
	}
}

static void
___lambda64__media_upload_progress_complete (MediaUpload* _sender,
                                             GError* _error_,
                                             gpointer self)
{
	__lambda64_ ((ComposedTweet*) self, _error_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
composed_tweet_add_attachment (ComposedTweet* self,
                               MediaUpload* upload)
{
	GPtrArray* _tmp0_;
	MediaUpload* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (upload != NULL);
	g_signal_connect (upload, "progress-complete", (GCallback) ___lambda64__media_upload_progress_complete, self);
	_tmp0_ = self->priv->_uploads;
	_tmp1_ = _g_object_ref0 (upload);
	g_ptr_array_add (_tmp0_, _tmp1_);
}

static MediaUpload**
_vala_array_dup8 (MediaUpload** self,
                  gint length)
{
	if (length >= 0) {
		MediaUpload** result;
		gint i;
		result = g_new0 (MediaUpload*, length + 1);
		for (i = 0; i < length; i++) {
			MediaUpload* _tmp0_;
			_tmp0_ = _g_object_ref0 (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

MediaUpload**
composed_tweet_get_attachments (ComposedTweet* self,
                                gint* result_length1)
{
	GPtrArray* _tmp0_;
	gpointer* _tmp1_;
	gint _tmp1__length1;
	MediaUpload** _tmp2_;
	gint _tmp2__length1;
	MediaUpload** _tmp3_;
	gint _tmp3__length1;
	MediaUpload** result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_uploads;
	_tmp1_ = _tmp0_->pdata;
	_tmp1__length1 = _tmp0_->len;
	_tmp2_ = (_tmp1_ != NULL) ? _vala_array_dup8 (_tmp1_, _tmp1__length1) : ((gpointer) _tmp1_);
	_tmp2__length1 = _tmp1__length1;
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _tmp2__length1;
	if (result_length1) {
		*result_length1 = _tmp3__length1;
	}
	result = _tmp3_;
	return result;
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = (gint) self->len;
	return result;
}

gchar*
composed_tweet_get_text (ComposedTweet* self)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = self->priv->_quoted_tweet_url;
	if (_tmp1_ != NULL) {
		GPtrArray* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		_tmp2_ = self->priv->_uploads;
		_tmp3_ = vala_g_ptr_array_get_length (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_ > 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		_tmp5_ = self->priv->_text;
		_tmp6_ = composed_tweet_get_quoted_url (self);
		_tmp7_ = _tmp6_;
		_tmp8_ = g_strdup_printf ("%s %s", _tmp5_, _tmp7_);
		_tmp9_ = _tmp8_;
		_g_free0 (_tmp7_);
		result = _tmp9_;
		return result;
	} else {
		const gchar* _tmp10_;
		gchar* _tmp11_;
		_tmp10_ = self->priv->_text;
		_tmp11_ = g_strdup (_tmp10_);
		result = _tmp11_;
		return result;
	}
}

gboolean
composed_tweet_has_quote_attachment (ComposedTweet* self)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = self->priv->_quoted_tweet_url;
	if (_tmp1_ != NULL) {
		GPtrArray* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		_tmp2_ = self->priv->_uploads;
		_tmp3_ = vala_g_ptr_array_get_length (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_ == 0;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

void
composed_tweet_set_quoted_tweet (ComposedTweet* self,
                                 CbTweet* tweet)
{
	gint64 _tmp0_;
	gint64 _tmp1_;
	CbMiniTweet* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (tweet != NULL);
	_tmp0_ = composed_tweet_get_reply_to_id (self);
	_tmp1_ = _tmp0_;
	_vala_assert (_tmp1_ == ((gint64) -1), "reply_to_id == -1");
	_tmp2_ = tweet->retweeted_tweet;
	if (_tmp2_ != NULL) {
		CbMiniTweet* _tmp3_;
		CbUserIdentity _tmp4_;
		const gchar* _tmp5_;
		CbMiniTweet* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		_tmp3_ = tweet->retweeted_tweet;
		_tmp4_ = (*_tmp3_).author;
		_tmp5_ = _tmp4_.screen_name;
		_tmp6_ = tweet->retweeted_tweet;
		_tmp7_ = g_strdup_printf ("%" G_GINT64_FORMAT, (*_tmp6_).id);
		_tmp8_ = _tmp7_;
		_tmp9_ = g_strdup_printf ("https://twitter.com/%s/status/%s", _tmp5_, _tmp8_);
		_g_free0 (self->priv->_quoted_tweet_url);
		self->priv->_quoted_tweet_url = _tmp9_;
		_g_free0 (_tmp8_);
	} else {
		CbMiniTweet _tmp10_;
		CbUserIdentity _tmp11_;
		const gchar* _tmp12_;
		CbMiniTweet _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		_tmp10_ = tweet->source_tweet;
		_tmp11_ = _tmp10_.author;
		_tmp12_ = _tmp11_.screen_name;
		_tmp13_ = tweet->source_tweet;
		_tmp14_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp13_.id);
		_tmp15_ = _tmp14_;
		_tmp16_ = g_strdup_printf ("https://twitter.com/%s/status/%s", _tmp12_, _tmp15_);
		_g_free0 (self->priv->_quoted_tweet_url);
		self->priv->_quoted_tweet_url = _tmp16_;
		_g_free0 (_tmp15_);
	}
}

gchar*
composed_tweet_get_quoted_url (ComposedTweet* self)
{
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	gchar* _tmp3_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = self->priv->_quoted_tweet_url;
	if (_tmp1_ == NULL) {
		_tmp0_ = "";
	} else {
		const gchar* _tmp2_;
		_tmp2_ = self->priv->_quoted_tweet_url;
		_tmp0_ = _tmp2_;
	}
	_tmp3_ = g_strdup (_tmp0_);
	result = _tmp3_;
	return result;
}

gint64
composed_tweet_get_reply_to_id (ComposedTweet* self)
{
	gint64 result;
	g_return_val_if_fail (self != NULL, 0LL);
	result = self->priv->_reply_to_id;
	return result;
}

void
composed_tweet_set_reply_to_id (ComposedTweet* self,
                                gint64 value)
{
	const gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_quoted_tweet_url;
	_vala_assert (_tmp0_ == NULL, "_quoted_tweet_url == null");
	self->priv->_reply_to_id = value;
}

static void
value_composed_tweet_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
value_composed_tweet_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		composed_tweet_unref (value->data[0].v_pointer);
	}
}

static void
value_composed_tweet_copy_value (const GValue* src_value,
                                 GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = composed_tweet_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
value_composed_tweet_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
value_composed_tweet_collect_value (GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		ComposedTweet * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = composed_tweet_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
value_composed_tweet_lcopy_value (const GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
	ComposedTweet ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = composed_tweet_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
param_spec_composed_tweet (const gchar* name,
                           const gchar* nick,
                           const gchar* blurb,
                           GType object_type,
                           GParamFlags flags)
{
	ParamSpecComposedTweet* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_COMPOSED_TWEET), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
value_get_composed_tweet (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_COMPOSED_TWEET), NULL);
	return value->data[0].v_pointer;
}

void
value_set_composed_tweet (GValue* value,
                          gpointer v_object)
{
	ComposedTweet * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_COMPOSED_TWEET));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_COMPOSED_TWEET));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		composed_tweet_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		composed_tweet_unref (old);
	}
}

void
value_take_composed_tweet (GValue* value,
                           gpointer v_object)
{
	ComposedTweet * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_COMPOSED_TWEET));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_COMPOSED_TWEET));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		composed_tweet_unref (old);
	}
}

static void
composed_tweet_class_init (ComposedTweetClass * klass,
                           gpointer klass_data)
{
	composed_tweet_parent_class = g_type_class_peek_parent (klass);
	((ComposedTweetClass *) klass)->finalize = composed_tweet_finalize;
	g_type_class_adjust_private_offset (klass, &ComposedTweet_private_offset);
	composed_tweet_signals[COMPOSED_TWEET_READY_SIGNAL] = g_signal_new ("ready", TYPE_COMPOSED_TWEET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
composed_tweet_instance_init (ComposedTweet * self,
                              gpointer klass)
{
	self->priv = composed_tweet_get_instance_private (self);
	self->priv->_reply_to_id = (gint64) -1;
	self->ref_count = 1;
}

static void
composed_tweet_finalize (ComposedTweet * obj)
{
	ComposedTweet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COMPOSED_TWEET, ComposedTweet);
	g_signal_handlers_destroy (self);
	_g_free0 (self->priv->_text);
	_g_ptr_array_unref0 (self->priv->_uploads);
	_g_free0 (self->priv->_quoted_tweet_url);
}

static GType
composed_tweet_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_composed_tweet_init, value_composed_tweet_free_value, value_composed_tweet_copy_value, value_composed_tweet_peek_pointer, "p", value_composed_tweet_collect_value, "p", value_composed_tweet_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (ComposedTweetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) composed_tweet_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ComposedTweet), 0, (GInstanceInitFunc) composed_tweet_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType composed_tweet_type_id;
	composed_tweet_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ComposedTweet", &g_define_type_info, &g_define_type_fundamental_info, 0);
	ComposedTweet_private_offset = g_type_add_instance_private (composed_tweet_type_id, sizeof (ComposedTweetPrivate));
	return composed_tweet_type_id;
}

GType
composed_tweet_get_type (void)
{
	static volatile gsize composed_tweet_type_id__volatile = 0;
	if (g_once_init_enter (&composed_tweet_type_id__volatile)) {
		GType composed_tweet_type_id;
		composed_tweet_type_id = composed_tweet_get_type_once ();
		g_once_init_leave (&composed_tweet_type_id__volatile, composed_tweet_type_id);
	}
	return composed_tweet_type_id__volatile;
}

gpointer
composed_tweet_ref (gpointer instance)
{
	ComposedTweet * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
composed_tweet_unref (gpointer instance)
{
	ComposedTweet * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		COMPOSED_TWEET_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

