/* ListUtils.c generated by valac 0.48.13, the Vala compiler
 * generated from ListUtils.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2020 IBBoard
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gio/gio.h>
#include <glib-object.h>
#include <glib.h>
#include <rest/rest-proxy-call.h>
#include <stdlib.h>
#include <string.h>
#include <rest/oauth-proxy.h>
#include "CbUserStream.h"
#include "CbUserCounter.h"
#include "CbFilter.h"
#include <rest/rest-proxy.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_ACCOUNT (account_get_type ())
#define ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ACCOUNT, Account))
#define ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ACCOUNT, AccountClass))
#define IS_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ACCOUNT))
#define IS_ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ACCOUNT))
#define ACCOUNT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ACCOUNT, AccountClass))

typedef struct _Account Account;
typedef struct _AccountClass AccountClass;
typedef struct _Block59Data Block59Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _AccountPrivate AccountPrivate;

#define SQL_TYPE_DATABASE (sql_database_get_type ())
#define SQL_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SQL_TYPE_DATABASE, SqlDatabase))
#define SQL_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SQL_TYPE_DATABASE, SqlDatabaseClass))
#define SQL_IS_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SQL_TYPE_DATABASE))
#define SQL_IS_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SQL_TYPE_DATABASE))
#define SQL_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SQL_TYPE_DATABASE, SqlDatabaseClass))

typedef struct _SqlDatabase SqlDatabase;
typedef struct _SqlDatabaseClass SqlDatabaseClass;

#define TYPE_NOTIFICATION_MANAGER (notification_manager_get_type ())
#define NOTIFICATION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NOTIFICATION_MANAGER, NotificationManager))
#define NOTIFICATION_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NOTIFICATION_MANAGER, NotificationManagerClass))
#define IS_NOTIFICATION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NOTIFICATION_MANAGER))
#define IS_NOTIFICATION_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NOTIFICATION_MANAGER))
#define NOTIFICATION_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NOTIFICATION_MANAGER, NotificationManagerClass))

typedef struct _NotificationManager NotificationManager;
typedef struct _NotificationManagerClass NotificationManagerClass;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ListUtilsDeleteListData ListUtilsDeleteListData;

struct _Block59Data {
	int _ref_count_;
	RestProxyCall* call;
	GError* err;
	gpointer _async_data_;
};

struct _Account {
	GObject parent_instance;
	AccountPrivate * priv;
	gint64 id;
	gint64 migration_date;
	gboolean suppress_dm_notifications;
	gboolean suppress_mention_notifications;
	SqlDatabase* db;
	gchar* screen_name;
	gchar* name;
	gchar* avatar_url;
	gchar* banner_url;
	gchar* website;
	gchar* description;
	OAuthProxy* proxy;
	CbUserStream* user_stream;
	CbUserCounter* user_counter;
	NotificationManager* notifications;
	gint64* friends;
	gint friends_length1;
	gint64* blocked;
	gint blocked_length1;
	gint64* muted;
	gint muted_length1;
	gint64* disabled_rts;
	gint disabled_rts_length1;
	GPtrArray* filters;
};

struct _AccountClass {
	GObjectClass parent_class;
};

struct _ListUtilsDeleteListData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	Account* account;
	gint64 to_rename;
	Block59Data* _data59_;
	OAuthProxy* _tmp0_;
	RestProxyCall* _tmp1_;
	RestProxyCall* _tmp2_;
	RestProxyCall* _tmp3_;
	RestProxyCall* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	RestProxyCall* _tmp7_;
	GError* _tmp8_;
	GError* _tmp9_;
	GError* _tmp10_;
	GError* _inner_error0_;
};

static void list_utils_delete_list_data_free (gpointer _data);
GType account_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Account, g_object_unref)
void list_utils_delete_list (Account* account,
                             gint64 to_rename,
                             GAsyncReadyCallback _callback_,
                             gpointer _user_data_);
void list_utils_delete_list_finish (GAsyncResult* _res_,
                                    GError** error);
static gboolean list_utils_delete_list_co (ListUtilsDeleteListData* _data_);
static Block59Data* block59_data_ref (Block59Data* _data59_);
static void block59_data_unref (void * _userdata_);
GType sql_database_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SqlDatabase, g_object_unref)
GType notification_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NotificationManager, g_object_unref)
static void __lambda100_ (Block59Data* _data59_,
                   GObject* obj,
                   GAsyncResult* res);
GError* tweet_utils_failed_request_to_error (RestProxyCall* call,
                                             GError* e);
GQuark tweet_utils_get_error_domain (void);
static void ___lambda100__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);

static void
list_utils_delete_list_data_free (gpointer _data)
{
	ListUtilsDeleteListData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->account);
	g_slice_free (ListUtilsDeleteListData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
list_utils_delete_list (Account* account,
                        gint64 to_rename,
                        GAsyncReadyCallback _callback_,
                        gpointer _user_data_)
{
	ListUtilsDeleteListData* _data_;
	Account* _tmp0_;
	_data_ = g_slice_new0 (ListUtilsDeleteListData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, list_utils_delete_list_data_free);
	_tmp0_ = _g_object_ref0 (account);
	_g_object_unref0 (_data_->account);
	_data_->account = _tmp0_;
	_data_->to_rename = to_rename;
	list_utils_delete_list_co (_data_);
}

void
list_utils_delete_list_finish (GAsyncResult* _res_,
                               GError** error)
{
	ListUtilsDeleteListData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return;
	}
}

static Block59Data*
block59_data_ref (Block59Data* _data59_)
{
	g_atomic_int_inc (&_data59_->_ref_count_);
	return _data59_;
}

static void
block59_data_unref (void * _userdata_)
{
	Block59Data* _data59_;
	_data59_ = (Block59Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data59_->_ref_count_)) {
		_g_error_free0 (_data59_->err);
		_g_object_unref0 (_data59_->call);
		g_slice_free (Block59Data, _data59_);
	}
}

static gpointer
_g_error_copy0 (gpointer self)
{
	return self ? g_error_copy (self) : NULL;
}

static void
__lambda100_ (Block59Data* _data59_,
              GObject* obj,
              GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (res != NULL);
	{
		RestProxyCall* _tmp0_;
		_tmp0_ = _data59_->call;
		rest_proxy_call_invoke_finish (_tmp0_, res, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* tmp_err = NULL;
		RestProxyCall* _tmp1_;
		GError* _tmp2_;
		GError* _tmp3_;
		gboolean _tmp4_ = FALSE;
		GError* _tmp5_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp1_ = _data59_->call;
		_tmp2_ = e;
		_tmp3_ = tweet_utils_failed_request_to_error (_tmp1_, _tmp2_);
		tmp_err = _tmp3_;
		_tmp5_ = tmp_err;
		if (_tmp5_->domain != tweet_utils_get_error_domain ()) {
			_tmp4_ = TRUE;
		} else {
			GError* _tmp6_;
			_tmp6_ = tmp_err;
			_tmp4_ = _tmp6_->code != 34;
		}
		if (_tmp4_) {
			GError* _tmp7_;
			GError* _tmp8_;
			_tmp7_ = tmp_err;
			_tmp8_ = _g_error_copy0 (_tmp7_);
			_g_error_free0 (_data59_->err);
			_data59_->err = _tmp8_;
		}
		_g_error_free0 (tmp_err);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	list_utils_delete_list_co (_data59_->_async_data_);
}

static void
___lambda100__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
	__lambda100_ (self, source_object, res);
	block59_data_unref (self);
}

static gboolean
list_utils_delete_list_co (ListUtilsDeleteListData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data59_ = g_slice_new0 (Block59Data);
	_data_->_data59_->_ref_count_ = 1;
	_data_->_data59_->_async_data_ = _data_;
	_data_->_tmp0_ = _data_->account->proxy;
	_data_->_tmp1_ = rest_proxy_new_call ((RestProxy*) _data_->_tmp0_);
	_data_->_data59_->call = _data_->_tmp1_;
	_data_->_tmp2_ = _data_->_data59_->call;
	rest_proxy_call_set_method (_data_->_tmp2_, "POST");
	_data_->_tmp3_ = _data_->_data59_->call;
	rest_proxy_call_set_function (_data_->_tmp3_, "1.1/lists/subscribers/create.json");
	_data_->_tmp4_ = _data_->_data59_->call;
	_data_->_tmp5_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->to_rename);
	_data_->_tmp6_ = _data_->_tmp5_;
	rest_proxy_call_add_param (_data_->_tmp4_, "list_id", _data_->_tmp6_);
	_g_free0 (_data_->_tmp6_);
	_data_->_data59_->err = NULL;
	_data_->_tmp7_ = _data_->_data59_->call;
	rest_proxy_call_invoke_async (_data_->_tmp7_, NULL, ___lambda100__gasync_ready_callback, block59_data_ref (_data_->_data59_));
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	_data_->_tmp8_ = _data_->_data59_->err;
	if (_data_->_tmp8_ != NULL) {
		_data_->_tmp9_ = _data_->_data59_->err;
		_data_->_tmp10_ = _g_error_copy0 (_data_->_tmp9_);
		_data_->_inner_error0_ = _data_->_tmp10_;
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
		block59_data_unref (_data_->_data59_);
		_data_->_data59_ = NULL;
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	block59_data_unref (_data_->_data59_);
	_data_->_data59_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

