/* UserUtils.c generated by valac 0.48.13, the Vala compiler
 * generated from UserUtils.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <json-glib/json-glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <rest/rest-proxy-call.h>
#include <rest/oauth-proxy.h>
#include "CbUserStream.h"
#include "CbUserCounter.h"
#include "CbFilter.h"
#include <rest/rest-proxy.h>
#include "CbUtils.h"

#define TYPE_JSON_CURSOR (json_cursor_get_type ())
typedef struct _JsonCursor JsonCursor;
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_ACCOUNT (account_get_type ())
#define ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ACCOUNT, Account))
#define ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ACCOUNT, AccountClass))
#define IS_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ACCOUNT))
#define IS_ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ACCOUNT))
#define ACCOUNT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ACCOUNT, AccountClass))

typedef struct _Account Account;
typedef struct _AccountClass AccountClass;
typedef struct _AccountPrivate AccountPrivate;

#define SQL_TYPE_DATABASE (sql_database_get_type ())
#define SQL_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SQL_TYPE_DATABASE, SqlDatabase))
#define SQL_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SQL_TYPE_DATABASE, SqlDatabaseClass))
#define SQL_IS_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SQL_TYPE_DATABASE))
#define SQL_IS_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SQL_TYPE_DATABASE))
#define SQL_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SQL_TYPE_DATABASE, SqlDatabaseClass))

typedef struct _SqlDatabase SqlDatabase;
typedef struct _SqlDatabaseClass SqlDatabaseClass;

#define TYPE_NOTIFICATION_MANAGER (notification_manager_get_type ())
#define NOTIFICATION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NOTIFICATION_MANAGER, NotificationManager))
#define NOTIFICATION_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NOTIFICATION_MANAGER, NotificationManagerClass))
#define IS_NOTIFICATION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NOTIFICATION_MANAGER))
#define IS_NOTIFICATION_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NOTIFICATION_MANAGER))
#define NOTIFICATION_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NOTIFICATION_MANAGER, NotificationManagerClass))

typedef struct _NotificationManager NotificationManager;
typedef struct _NotificationManagerClass NotificationManagerClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
typedef struct _UserUtilsLoadFriendshipData UserUtilsLoadFriendshipData;
#define _json_cursor_free0(var) ((var == NULL) ? NULL : (var = (json_cursor_free (var), NULL)))
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))
typedef struct _UserUtilsLoadFollowersData UserUtilsLoadFollowersData;
typedef struct _UserUtilsLoadFollowingData UserUtilsLoadFollowingData;
typedef struct _Block72Data Block72Data;
typedef struct _UserUtilsMuteUserData UserUtilsMuteUserData;
typedef struct _Block73Data Block73Data;
typedef struct _UserUtilsBlockUserData UserUtilsBlockUserData;
typedef struct _UserUtilsLoadUserTimelineByIdData UserUtilsLoadUserTimelineByIdData;
typedef struct _UserUtilsLoadUserTimelineByScreenNameData UserUtilsLoadUserTimelineByScreenNameData;
typedef struct _UserUtilsLoadUserTimelineData UserUtilsLoadUserTimelineData;

struct _JsonCursor {
	gint64 next_cursor;
	gboolean full;
	JsonNode* json_object;
};

struct _Account {
	GObject parent_instance;
	AccountPrivate * priv;
	gint64 id;
	gint64 migration_date;
	gboolean suppress_dm_notifications;
	gboolean suppress_mention_notifications;
	SqlDatabase* db;
	gchar* screen_name;
	gchar* name;
	gchar* avatar_url;
	gchar* banner_url;
	gchar* website;
	gchar* description;
	OAuthProxy* proxy;
	CbUserStream* user_stream;
	CbUserCounter* user_counter;
	NotificationManager* notifications;
	gint64* friends;
	gint friends_length1;
	gint64* blocked;
	gint blocked_length1;
	gint64* muted;
	gint muted_length1;
	gint64* disabled_rts;
	gint disabled_rts_length1;
	GPtrArray* filters;
};

struct _AccountClass {
	GObjectClass parent_class;
};

struct _UserUtilsLoadFriendshipData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	Account* account;
	gint64 user_id;
	gchar* screen_name;
	guint result;
	RestProxyCall* call;
	OAuthProxy* _tmp0_;
	RestProxyCall* _tmp1_;
	RestProxyCall* _tmp2_;
	RestProxyCall* _tmp3_;
	RestProxyCall* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	RestProxyCall* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	RestProxyCall* _tmp10_;
	JsonNode* root;
	JsonNode* _tmp11_;
	RestProxyCall* _tmp12_;
	JsonNode* _tmp13_;
	JsonNode* _tmp14_;
	GError* e;
	GError* _tmp15_;
	const gchar* _tmp16_;
	JsonObject* relationship;
	JsonNode* _tmp17_;
	JsonObject* _tmp18_;
	JsonObject* _tmp19_;
	JsonObject* _tmp20_;
	JsonObject* target;
	JsonObject* _tmp21_;
	JsonObject* _tmp22_;
	JsonObject* _tmp23_;
	JsonObject* source;
	JsonObject* _tmp24_;
	JsonObject* _tmp25_;
	JsonObject* _tmp26_;
	guint friendship;
	JsonObject* _tmp27_;
	JsonObject* _tmp28_;
	JsonObject* _tmp29_;
	JsonObject* _tmp30_;
	JsonObject* _tmp31_;
	JsonObject* _tmp32_;
	GError* _inner_error0_;
};

struct _UserUtilsLoadFollowersData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	Account* account;
	gint64 user_id;
	JsonCursor* old_cursor;
	JsonCursor* result;
	RestProxyCall* call;
	OAuthProxy* _tmp0_;
	RestProxyCall* _tmp1_;
	RestProxyCall* _tmp2_;
	RestProxyCall* _tmp3_;
	RestProxyCall* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	RestProxyCall* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	RestProxyCall* _tmp10_;
	RestProxyCall* _tmp11_;
	RestProxyCall* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	JsonNode* root;
	JsonNode* _tmp15_;
	RestProxyCall* _tmp16_;
	JsonNode* _tmp17_;
	JsonNode* _tmp18_;
	GError* e;
	GError* _tmp19_;
	const gchar* _tmp20_;
	JsonObject* root_obj;
	JsonNode* _tmp21_;
	JsonObject* _tmp22_;
	JsonObject* _tmp23_;
	JsonArray* user_array;
	JsonObject* _tmp24_;
	JsonArray* _tmp25_;
	JsonArray* _tmp26_;
	JsonCursor cursor;
	JsonObject* _tmp27_;
	JsonArray* _tmp28_;
	JsonObject* _tmp29_;
	JsonNode* _tmp30_;
	JsonNode* _tmp31_;
	JsonCursor _tmp32_;
	JsonCursor* _tmp33_;
	JsonCursor* _tmp34_;
	GError* _inner_error0_;
};

struct _UserUtilsLoadFollowingData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	Account* account;
	gint64 user_id;
	JsonCursor* old_cursor;
	JsonCursor* result;
	RestProxyCall* call;
	OAuthProxy* _tmp0_;
	RestProxyCall* _tmp1_;
	RestProxyCall* _tmp2_;
	RestProxyCall* _tmp3_;
	RestProxyCall* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	RestProxyCall* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	RestProxyCall* _tmp10_;
	RestProxyCall* _tmp11_;
	RestProxyCall* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	JsonNode* root;
	JsonNode* _tmp15_;
	RestProxyCall* _tmp16_;
	JsonNode* _tmp17_;
	JsonNode* _tmp18_;
	GError* e;
	GError* _tmp19_;
	const gchar* _tmp20_;
	JsonObject* root_obj;
	JsonNode* _tmp21_;
	JsonObject* _tmp22_;
	JsonObject* _tmp23_;
	JsonArray* user_array;
	JsonObject* _tmp24_;
	JsonArray* _tmp25_;
	JsonArray* _tmp26_;
	JsonCursor cursor;
	JsonObject* _tmp27_;
	JsonArray* _tmp28_;
	JsonObject* _tmp29_;
	JsonNode* _tmp30_;
	JsonNode* _tmp31_;
	JsonCursor _tmp32_;
	JsonCursor* _tmp33_;
	JsonCursor* _tmp34_;
	GError* _inner_error0_;
};

struct _Block72Data {
	int _ref_count_;
	RestProxyCall* call;
	GError* err;
	Account* account;
	gboolean setting;
	gpointer _async_data_;
};

struct _UserUtilsMuteUserData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	Account* account;
	gint64 to_block;
	gboolean setting;
	Block72Data* _data72_;
	OAuthProxy* _tmp0_;
	RestProxyCall* _tmp1_;
	RestProxyCall* _tmp2_;
	RestProxyCall* _tmp3_;
	RestProxyCall* _tmp4_;
	RestProxyCall* _tmp5_;
	RestProxyCall* _tmp6_;
	RestProxyCall* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	RestProxyCall* _tmp10_;
	GError* _tmp11_;
	GError* _tmp12_;
	GError* _tmp13_;
	GError* _inner_error0_;
};

struct _Block73Data {
	int _ref_count_;
	RestProxyCall* call;
	GError* err;
	Account* account;
	gboolean setting;
	gpointer _async_data_;
};

struct _UserUtilsBlockUserData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	Account* account;
	gint64 to_block;
	gboolean setting;
	Block73Data* _data73_;
	OAuthProxy* _tmp0_;
	RestProxyCall* _tmp1_;
	RestProxyCall* _tmp2_;
	RestProxyCall* _tmp3_;
	RestProxyCall* _tmp4_;
	RestProxyCall* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	RestProxyCall* _tmp8_;
	RestProxyCall* _tmp9_;
	RestProxyCall* _tmp10_;
	GError* _tmp11_;
	GError* _tmp12_;
	GError* _tmp13_;
	GError* _inner_error0_;
};

struct _UserUtilsLoadUserTimelineByIdData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	Account* account;
	gint64 user_id;
	gint tweet_count;
	gint64 since_id;
	gint64 max_id;
	JsonArray* result;
	JsonArray* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	JsonArray* _tmp3_;
	JsonArray* _tmp4_;
	JsonArray* _tmp5_;
	GError* _inner_error0_;
};

struct _UserUtilsLoadUserTimelineByScreenNameData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	Account* account;
	gchar* screen_name;
	gint tweet_count;
	gint64 since_id;
	gint64 max_id;
	JsonArray* result;
	JsonArray* _tmp0_;
	JsonArray* _tmp1_;
	JsonArray* _tmp2_;
	GError* _inner_error0_;
};

struct _UserUtilsLoadUserTimelineData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	Account* account;
	gchar* field;
	gchar* value;
	gint tweet_count;
	gint64 since_id;
	gint64 max_id;
	JsonArray* result;
	RestProxyCall* call;
	OAuthProxy* _tmp0_;
	RestProxyCall* _tmp1_;
	RestProxyCall* _tmp2_;
	RestProxyCall* _tmp3_;
	RestProxyCall* _tmp4_;
	RestProxyCall* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	RestProxyCall* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	RestProxyCall* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	RestProxyCall* _tmp14_;
	RestProxyCall* _tmp15_;
	RestProxyCall* _tmp16_;
	RestProxyCall* _tmp17_;
	JsonNode* root;
	JsonArray* array;
	JsonNode* _tmp18_;
	RestProxyCall* _tmp19_;
	JsonNode* _tmp20_;
	JsonNode* _tmp21_;
	JsonNode* _tmp22_;
	JsonNode* _tmp23_;
	JsonArray* _tmp24_;
	JsonArray* _tmp25_;
	GError* e;
	gboolean _tmp26_;
	GError* _tmp27_;
	GError* _tmp28_;
	GError* _tmp29_;
	GError* _tmp30_;
	JsonArray* _tmp31_;
	JsonArray* _tmp32_;
	JsonArray* _tmp33_;
	GError* _tmp34_;
	GError* _tmp35_;
	JsonArray* _tmp36_;
	JsonArray* _tmp37_;
	JsonArray* _tmp38_;
	JsonArray* _tmp39_;
	JsonArray* _tmp40_;
	GError* _inner_error0_;
};

#define FRIENDSHIP_FOLLOWED_BY ((guint) (1 << 0))
#define FRIENDSHIP_FOLLOWING ((guint) (1 << 1))
#define FRIENDSHIP_WANT_RETWEETS ((guint) (1 << 2))
#define FRIENDSHIP_BLOCKING ((guint) (1 << 3))
#define FRIENDSHIP_MUTING ((guint) (1 << 4))
#define FRIENDSHIP_CAN_DM ((guint) (1 << 5))
GType json_cursor_get_type (void) G_GNUC_CONST;
JsonCursor* json_cursor_dup (const JsonCursor* self);
void json_cursor_free (JsonCursor* self);
void json_cursor_copy (const JsonCursor* self,
                       JsonCursor* dest);
void json_cursor_destroy (JsonCursor* self);
static void _vala_JsonNode_free (JsonNode* self);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
static void user_utils_load_friendship_data_free (gpointer _data);
GType account_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Account, g_object_unref)
void user_utils_load_friendship (Account* account,
                                 gint64 user_id,
                                 const gchar* screen_name,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
guint user_utils_load_friendship_finish (GAsyncResult* _res_);
static gboolean user_utils_load_friendship_co (UserUtilsLoadFriendshipData* _data_);
GType sql_database_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SqlDatabase, g_object_unref)
GType notification_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NotificationManager, g_object_unref)
static void user_utils_load_friendship_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_);
static void user_utils_load_followers_data_free (gpointer _data);
void user_utils_load_followers (Account* account,
                                gint64 user_id,
                                JsonCursor* old_cursor,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_);
JsonCursor* user_utils_load_followers_finish (GAsyncResult* _res_);
static gboolean user_utils_load_followers_co (UserUtilsLoadFollowersData* _data_);
static void user_utils_load_followers_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_);
static void user_utils_load_following_data_free (gpointer _data);
void user_utils_load_following (Account* account,
                                gint64 user_id,
                                JsonCursor* old_cursor,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_);
JsonCursor* user_utils_load_following_finish (GAsyncResult* _res_);
static gboolean user_utils_load_following_co (UserUtilsLoadFollowingData* _data_);
static void user_utils_load_following_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_);
static void user_utils_mute_user_data_free (gpointer _data);
void user_utils_mute_user (Account* account,
                           gint64 to_block,
                           gboolean setting,
                           GAsyncReadyCallback _callback_,
                           gpointer _user_data_);
void user_utils_mute_user_finish (GAsyncResult* _res_,
                                  GError** error);
static gboolean user_utils_mute_user_co (UserUtilsMuteUserData* _data_);
static Block72Data* block72_data_ref (Block72Data* _data72_);
static void block72_data_unref (void * _userdata_);
static void __lambda196_ (Block72Data* _data72_,
                   GObject* obj,
                   GAsyncResult* res);
void tweet_utils_inject_user_mute (const gchar* user_json,
                                   Account* account);
void tweet_utils_inject_user_unmute (const gchar* user_json,
                                     Account* account);
GError* tweet_utils_failed_request_to_error (RestProxyCall* call,
                                             GError* e);
GQuark tweet_utils_get_error_domain (void);
static void ___lambda196__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void user_utils_block_user_data_free (gpointer _data);
void user_utils_block_user (Account* account,
                            gint64 to_block,
                            gboolean setting,
                            GAsyncReadyCallback _callback_,
                            gpointer _user_data_);
void user_utils_block_user_finish (GAsyncResult* _res_,
                                   GError** error);
static gboolean user_utils_block_user_co (UserUtilsBlockUserData* _data_);
static Block73Data* block73_data_ref (Block73Data* _data73_);
static void block73_data_unref (void * _userdata_);
static void __lambda194_ (Block73Data* _data73_,
                   GObject* obj,
                   GAsyncResult* res);
void tweet_utils_inject_user_block (const gchar* user_json,
                                    Account* account);
void tweet_utils_inject_user_unblock (const gchar* user_json,
                                      Account* account);
static void ___lambda194__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void user_utils_load_user_timeline_by_id_data_free (gpointer _data);
void user_utils_load_user_timeline_by_id (Account* account,
                                          gint64 user_id,
                                          gint tweet_count,
                                          gint64 since_id,
                                          gint64 max_id,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_);
JsonArray* user_utils_load_user_timeline_by_id_finish (GAsyncResult* _res_,
                                                       GError** error);
static gboolean user_utils_load_user_timeline_by_id_co (UserUtilsLoadUserTimelineByIdData* _data_);
void user_utils_load_user_timeline (Account* account,
                                    const gchar* field,
                                    const gchar* value,
                                    gint tweet_count,
                                    gint64 since_id,
                                    gint64 max_id,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_);
JsonArray* user_utils_load_user_timeline_finish (GAsyncResult* _res_,
                                                 GError** error);
static void user_utils_load_user_timeline_by_id_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_);
static void user_utils_load_user_timeline_by_screen_name_data_free (gpointer _data);
void user_utils_load_user_timeline_by_screen_name (Account* account,
                                                   const gchar* screen_name,
                                                   gint tweet_count,
                                                   gint64 since_id,
                                                   gint64 max_id,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
JsonArray* user_utils_load_user_timeline_by_screen_name_finish (GAsyncResult* _res_,
                                                                GError** error);
static gboolean user_utils_load_user_timeline_by_screen_name_co (UserUtilsLoadUserTimelineByScreenNameData* _data_);
static void user_utils_load_user_timeline_by_screen_name_ready (GObject* source_object,
                                                         GAsyncResult* _res_,
                                                         gpointer _user_data_);
static void user_utils_load_user_timeline_data_free (gpointer _data);
static gboolean user_utils_load_user_timeline_co (UserUtilsLoadUserTimelineData* _data_);
static void user_utils_load_user_timeline_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_);

static void
_vala_JsonNode_free (JsonNode* self)
{
	g_boxed_free (json_node_get_type (), self);
}

static JsonNode*
_vala_JsonNode_copy (JsonNode* self)
{
	return g_boxed_copy (json_node_get_type (), self);
}

static gpointer
__vala_JsonNode_copy0 (gpointer self)
{
	return self ? _vala_JsonNode_copy (self) : NULL;
}

void
json_cursor_copy (const JsonCursor* self,
                  JsonCursor* dest)
{
	JsonNode* _tmp0_;
	JsonNode* _tmp1_;
	(*dest).next_cursor = (*self).next_cursor;
	(*dest).full = (*self).full;
	_tmp0_ = (*self).json_object;
	_tmp1_ = __vala_JsonNode_copy0 (_tmp0_);
	__vala_JsonNode_free0 ((*dest).json_object);
	(*dest).json_object = _tmp1_;
}

void
json_cursor_destroy (JsonCursor* self)
{
	__vala_JsonNode_free0 ((*self).json_object);
}

JsonCursor*
json_cursor_dup (const JsonCursor* self)
{
	JsonCursor* dup;
	dup = g_new0 (JsonCursor, 1);
	json_cursor_copy (self, dup);
	return dup;
}

void
json_cursor_free (JsonCursor* self)
{
	json_cursor_destroy (self);
	g_free (self);
}

static GType
json_cursor_get_type_once (void)
{
	GType json_cursor_type_id;
	json_cursor_type_id = g_boxed_type_register_static ("JsonCursor", (GBoxedCopyFunc) json_cursor_dup, (GBoxedFreeFunc) json_cursor_free);
	return json_cursor_type_id;
}

GType
json_cursor_get_type (void)
{
	static volatile gsize json_cursor_type_id__volatile = 0;
	if (g_once_init_enter (&json_cursor_type_id__volatile)) {
		GType json_cursor_type_id;
		json_cursor_type_id = json_cursor_get_type_once ();
		g_once_init_leave (&json_cursor_type_id__volatile, json_cursor_type_id);
	}
	return json_cursor_type_id__volatile;
}

static void
user_utils_load_friendship_data_free (gpointer _data)
{
	UserUtilsLoadFriendshipData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->account);
	_g_free0 (_data_->screen_name);
	g_slice_free (UserUtilsLoadFriendshipData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
user_utils_load_friendship (Account* account,
                            gint64 user_id,
                            const gchar* screen_name,
                            GAsyncReadyCallback _callback_,
                            gpointer _user_data_)
{
	UserUtilsLoadFriendshipData* _data_;
	Account* _tmp0_;
	gchar* _tmp1_;
	_data_ = g_slice_new0 (UserUtilsLoadFriendshipData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, user_utils_load_friendship_data_free);
	_tmp0_ = _g_object_ref0 (account);
	_g_object_unref0 (_data_->account);
	_data_->account = _tmp0_;
	_data_->user_id = user_id;
	_tmp1_ = g_strdup (screen_name);
	_g_free0 (_data_->screen_name);
	_data_->screen_name = _tmp1_;
	user_utils_load_friendship_co (_data_);
}

guint
user_utils_load_friendship_finish (GAsyncResult* _res_)
{
	guint result;
	UserUtilsLoadFriendshipData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	return result;
}

static void
user_utils_load_friendship_ready (GObject* source_object,
                                  GAsyncResult* _res_,
                                  gpointer _user_data_)
{
	UserUtilsLoadFriendshipData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	user_utils_load_friendship_co (_data_);
}

static gpointer
_json_object_ref0 (gpointer self)
{
	return self ? json_object_ref (self) : NULL;
}

static gboolean
user_utils_load_friendship_co (UserUtilsLoadFriendshipData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->account->proxy;
	_data_->_tmp1_ = rest_proxy_new_call ((RestProxy*) _data_->_tmp0_);
	_data_->call = _data_->_tmp1_;
	_data_->_tmp2_ = _data_->call;
	rest_proxy_call_set_function (_data_->_tmp2_, "1.1/friendships/show.json");
	_data_->_tmp3_ = _data_->call;
	rest_proxy_call_set_method (_data_->_tmp3_, "GET");
	_data_->_tmp4_ = _data_->call;
	_data_->_tmp5_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->account->id);
	_data_->_tmp6_ = _data_->_tmp5_;
	rest_proxy_call_add_param (_data_->_tmp4_, "source_id", _data_->_tmp6_);
	_g_free0 (_data_->_tmp6_);
	if (_data_->user_id != ((gint64) 0)) {
		_data_->_tmp7_ = _data_->call;
		_data_->_tmp8_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->user_id);
		_data_->_tmp9_ = _data_->_tmp8_;
		rest_proxy_call_add_param (_data_->_tmp7_, "target_id", _data_->_tmp9_);
		_g_free0 (_data_->_tmp9_);
	} else {
		_data_->_tmp10_ = _data_->call;
		rest_proxy_call_add_param (_data_->_tmp10_, "target_screen_name", _data_->screen_name);
	}
	_data_->root = NULL;
	{
		_data_->_tmp12_ = _data_->call;
		_data_->_state_ = 1;
		cb_utils_load_threaded_async (_data_->_tmp12_, NULL, user_utils_load_friendship_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp13_ = cb_utils_load_threaded_finish (_data_->_res_, &_data_->_inner_error0_);
		_data_->_tmp11_ = _data_->_tmp13_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->_tmp14_ = _data_->_tmp11_;
		_data_->_tmp11_ = NULL;
		__vala_JsonNode_free0 (_data_->root);
		_data_->root = _data_->_tmp14_;
		__vala_JsonNode_free0 (_data_->_tmp11_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp15_ = _data_->e;
		_data_->_tmp16_ = _data_->_tmp15_->message;
		g_warning ("UserUtils.vala:52: %s", _data_->_tmp16_);
		_data_->result = (guint) 0;
		_g_error_free0 (_data_->e);
		__vala_JsonNode_free0 (_data_->root);
		_g_object_unref0 (_data_->call);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		__vala_JsonNode_free0 (_data_->root);
		_g_object_unref0 (_data_->call);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp17_ = _data_->root;
	_data_->_tmp18_ = json_node_get_object (_data_->_tmp17_);
	_data_->_tmp19_ = json_object_get_object_member (_data_->_tmp18_, "relationship");
	_data_->_tmp20_ = _json_object_ref0 (_data_->_tmp19_);
	_data_->relationship = _data_->_tmp20_;
	_data_->_tmp21_ = _data_->relationship;
	_data_->_tmp22_ = json_object_get_object_member (_data_->_tmp21_, "target");
	_data_->_tmp23_ = _json_object_ref0 (_data_->_tmp22_);
	_data_->target = _data_->_tmp23_;
	_data_->_tmp24_ = _data_->relationship;
	_data_->_tmp25_ = json_object_get_object_member (_data_->_tmp24_, "source");
	_data_->_tmp26_ = _json_object_ref0 (_data_->_tmp25_);
	_data_->source = _data_->_tmp26_;
	_data_->friendship = (guint) 0;
	_data_->_tmp27_ = _data_->target;
	if (json_object_get_boolean_member (_data_->_tmp27_, "following")) {
		_data_->friendship |= FRIENDSHIP_FOLLOWED_BY;
	}
	_data_->_tmp28_ = _data_->target;
	if (json_object_get_boolean_member (_data_->_tmp28_, "followed_by")) {
		_data_->friendship |= FRIENDSHIP_FOLLOWING;
	}
	_data_->_tmp29_ = _data_->source;
	if (json_object_get_boolean_member (_data_->_tmp29_, "want_retweets")) {
		_data_->friendship |= FRIENDSHIP_WANT_RETWEETS;
	}
	_data_->_tmp30_ = _data_->source;
	if (json_object_get_boolean_member (_data_->_tmp30_, "blocking")) {
		_data_->friendship |= FRIENDSHIP_BLOCKING;
	}
	_data_->_tmp31_ = _data_->source;
	if (json_object_get_boolean_member (_data_->_tmp31_, "muting")) {
		_data_->friendship |= FRIENDSHIP_MUTING;
	}
	_data_->_tmp32_ = _data_->source;
	if (json_object_get_boolean_member (_data_->_tmp32_, "can_dm")) {
		_data_->friendship |= FRIENDSHIP_CAN_DM;
	}
	_data_->result = _data_->friendship;
	_json_object_unref0 (_data_->source);
	_json_object_unref0 (_data_->target);
	_json_object_unref0 (_data_->relationship);
	__vala_JsonNode_free0 (_data_->root);
	_g_object_unref0 (_data_->call);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
user_utils_load_followers_data_free (gpointer _data)
{
	UserUtilsLoadFollowersData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->account);
	_json_cursor_free0 (_data_->old_cursor);
	_json_cursor_free0 (_data_->result);
	g_slice_free (UserUtilsLoadFollowersData, _data_);
}

static gpointer
_json_cursor_dup0 (gpointer self)
{
	return self ? json_cursor_dup (self) : NULL;
}

void
user_utils_load_followers (Account* account,
                           gint64 user_id,
                           JsonCursor* old_cursor,
                           GAsyncReadyCallback _callback_,
                           gpointer _user_data_)
{
	UserUtilsLoadFollowersData* _data_;
	Account* _tmp0_;
	JsonCursor* _tmp1_;
	_data_ = g_slice_new0 (UserUtilsLoadFollowersData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, user_utils_load_followers_data_free);
	_tmp0_ = _g_object_ref0 (account);
	_g_object_unref0 (_data_->account);
	_data_->account = _tmp0_;
	_data_->user_id = user_id;
	_tmp1_ = _json_cursor_dup0 (old_cursor);
	_json_cursor_free0 (_data_->old_cursor);
	_data_->old_cursor = _tmp1_;
	user_utils_load_followers_co (_data_);
}

JsonCursor*
user_utils_load_followers_finish (GAsyncResult* _res_)
{
	JsonCursor* result;
	UserUtilsLoadFollowersData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static void
user_utils_load_followers_ready (GObject* source_object,
                                 GAsyncResult* _res_,
                                 gpointer _user_data_)
{
	UserUtilsLoadFollowersData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	user_utils_load_followers_co (_data_);
}

static gpointer
_json_array_ref0 (gpointer self)
{
	return self ? json_array_ref (self) : NULL;
}

static gboolean
user_utils_load_followers_co (UserUtilsLoadFollowersData* _data_)
{
	static const gint requested = 25;
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->account->proxy;
	_data_->_tmp1_ = rest_proxy_new_call ((RestProxy*) _data_->_tmp0_);
	_data_->call = _data_->_tmp1_;
	_data_->_tmp2_ = _data_->call;
	rest_proxy_call_set_function (_data_->_tmp2_, "1.1/followers/list.json");
	_data_->_tmp3_ = _data_->call;
	rest_proxy_call_set_method (_data_->_tmp3_, "GET");
	_data_->_tmp4_ = _data_->call;
	_data_->_tmp5_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->user_id);
	_data_->_tmp6_ = _data_->_tmp5_;
	rest_proxy_call_add_param (_data_->_tmp4_, "user_id", _data_->_tmp6_);
	_g_free0 (_data_->_tmp6_);
	_data_->_tmp7_ = _data_->call;
	_data_->_tmp8_ = g_strdup_printf ("%i", requested);
	_data_->_tmp9_ = _data_->_tmp8_;
	rest_proxy_call_add_param (_data_->_tmp7_, "count", _data_->_tmp9_);
	_g_free0 (_data_->_tmp9_);
	_data_->_tmp10_ = _data_->call;
	rest_proxy_call_add_param (_data_->_tmp10_, "skip_status", "true");
	_data_->_tmp11_ = _data_->call;
	rest_proxy_call_add_param (_data_->_tmp11_, "include_user_entities", "false");
	if (_data_->old_cursor != NULL) {
		_data_->_tmp12_ = _data_->call;
		_data_->_tmp13_ = g_strdup_printf ("%" G_GINT64_FORMAT, (*_data_->old_cursor).next_cursor);
		_data_->_tmp14_ = _data_->_tmp13_;
		rest_proxy_call_add_param (_data_->_tmp12_, "cursor", _data_->_tmp14_);
		_g_free0 (_data_->_tmp14_);
	}
	_data_->root = NULL;
	{
		_data_->_tmp16_ = _data_->call;
		_data_->_state_ = 1;
		cb_utils_load_threaded_async (_data_->_tmp16_, NULL, user_utils_load_followers_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp17_ = cb_utils_load_threaded_finish (_data_->_res_, &_data_->_inner_error0_);
		_data_->_tmp15_ = _data_->_tmp17_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->_tmp18_ = _data_->_tmp15_;
		_data_->_tmp15_ = NULL;
		__vala_JsonNode_free0 (_data_->root);
		_data_->root = _data_->_tmp18_;
		__vala_JsonNode_free0 (_data_->_tmp15_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp19_ = _data_->e;
		_data_->_tmp20_ = _data_->_tmp19_->message;
		g_warning ("UserUtils.vala:103: %s", _data_->_tmp20_);
		_data_->result = NULL;
		_g_error_free0 (_data_->e);
		__vala_JsonNode_free0 (_data_->root);
		_g_object_unref0 (_data_->call);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		__vala_JsonNode_free0 (_data_->root);
		_g_object_unref0 (_data_->call);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp21_ = _data_->root;
	_data_->_tmp22_ = json_node_get_object (_data_->_tmp21_);
	_data_->_tmp23_ = _json_object_ref0 (_data_->_tmp22_);
	_data_->root_obj = _data_->_tmp23_;
	_data_->_tmp24_ = _data_->root_obj;
	_data_->_tmp25_ = json_object_get_array_member (_data_->_tmp24_, "users");
	_data_->_tmp26_ = _json_array_ref0 (_data_->_tmp25_);
	_data_->user_array = _data_->_tmp26_;
	memset (&_data_->cursor, 0, sizeof (JsonCursor));
	_data_->_tmp27_ = _data_->root_obj;
	_data_->cursor.next_cursor = json_object_get_int_member (_data_->_tmp27_, "next_cursor");
	_data_->_tmp28_ = _data_->user_array;
	_data_->cursor.full = json_array_get_length (_data_->_tmp28_) < ((guint) requested);
	_data_->_tmp29_ = _data_->root_obj;
	_data_->_tmp30_ = json_object_get_member (_data_->_tmp29_, "users");
	_data_->_tmp31_ = __vala_JsonNode_copy0 (_data_->_tmp30_);
	__vala_JsonNode_free0 (_data_->cursor.json_object);
	_data_->cursor.json_object = _data_->_tmp31_;
	_data_->_tmp32_ = _data_->cursor;
	_data_->_tmp33_ = _json_cursor_dup0 (&_data_->_tmp32_);
	_data_->_tmp34_ = _data_->_tmp33_;
	json_cursor_destroy (&_data_->_tmp32_);
	_data_->result = _data_->_tmp34_;
	_json_array_unref0 (_data_->user_array);
	_json_object_unref0 (_data_->root_obj);
	__vala_JsonNode_free0 (_data_->root);
	_g_object_unref0 (_data_->call);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
user_utils_load_following_data_free (gpointer _data)
{
	UserUtilsLoadFollowingData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->account);
	_json_cursor_free0 (_data_->old_cursor);
	_json_cursor_free0 (_data_->result);
	g_slice_free (UserUtilsLoadFollowingData, _data_);
}

void
user_utils_load_following (Account* account,
                           gint64 user_id,
                           JsonCursor* old_cursor,
                           GAsyncReadyCallback _callback_,
                           gpointer _user_data_)
{
	UserUtilsLoadFollowingData* _data_;
	Account* _tmp0_;
	JsonCursor* _tmp1_;
	_data_ = g_slice_new0 (UserUtilsLoadFollowingData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, user_utils_load_following_data_free);
	_tmp0_ = _g_object_ref0 (account);
	_g_object_unref0 (_data_->account);
	_data_->account = _tmp0_;
	_data_->user_id = user_id;
	_tmp1_ = _json_cursor_dup0 (old_cursor);
	_json_cursor_free0 (_data_->old_cursor);
	_data_->old_cursor = _tmp1_;
	user_utils_load_following_co (_data_);
}

JsonCursor*
user_utils_load_following_finish (GAsyncResult* _res_)
{
	JsonCursor* result;
	UserUtilsLoadFollowingData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static void
user_utils_load_following_ready (GObject* source_object,
                                 GAsyncResult* _res_,
                                 gpointer _user_data_)
{
	UserUtilsLoadFollowingData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	user_utils_load_following_co (_data_);
}

static gboolean
user_utils_load_following_co (UserUtilsLoadFollowingData* _data_)
{
	static const gint requested = 25;
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->account->proxy;
	_data_->_tmp1_ = rest_proxy_new_call ((RestProxy*) _data_->_tmp0_);
	_data_->call = _data_->_tmp1_;
	_data_->_tmp2_ = _data_->call;
	rest_proxy_call_set_function (_data_->_tmp2_, "1.1/friends/list.json");
	_data_->_tmp3_ = _data_->call;
	rest_proxy_call_set_method (_data_->_tmp3_, "GET");
	_data_->_tmp4_ = _data_->call;
	_data_->_tmp5_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->user_id);
	_data_->_tmp6_ = _data_->_tmp5_;
	rest_proxy_call_add_param (_data_->_tmp4_, "user_id", _data_->_tmp6_);
	_g_free0 (_data_->_tmp6_);
	_data_->_tmp7_ = _data_->call;
	_data_->_tmp8_ = g_strdup_printf ("%i", requested);
	_data_->_tmp9_ = _data_->_tmp8_;
	rest_proxy_call_add_param (_data_->_tmp7_, "count", _data_->_tmp9_);
	_g_free0 (_data_->_tmp9_);
	_data_->_tmp10_ = _data_->call;
	rest_proxy_call_add_param (_data_->_tmp10_, "skip_status", "true");
	_data_->_tmp11_ = _data_->call;
	rest_proxy_call_add_param (_data_->_tmp11_, "include_user_entities", "false");
	if (_data_->old_cursor != NULL) {
		_data_->_tmp12_ = _data_->call;
		_data_->_tmp13_ = g_strdup_printf ("%" G_GINT64_FORMAT, (*_data_->old_cursor).next_cursor);
		_data_->_tmp14_ = _data_->_tmp13_;
		rest_proxy_call_add_param (_data_->_tmp12_, "cursor", _data_->_tmp14_);
		_g_free0 (_data_->_tmp14_);
	}
	_data_->root = NULL;
	{
		_data_->_tmp16_ = _data_->call;
		_data_->_state_ = 1;
		cb_utils_load_threaded_async (_data_->_tmp16_, NULL, user_utils_load_following_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp17_ = cb_utils_load_threaded_finish (_data_->_res_, &_data_->_inner_error0_);
		_data_->_tmp15_ = _data_->_tmp17_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->_tmp18_ = _data_->_tmp15_;
		_data_->_tmp15_ = NULL;
		__vala_JsonNode_free0 (_data_->root);
		_data_->root = _data_->_tmp18_;
		__vala_JsonNode_free0 (_data_->_tmp15_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp19_ = _data_->e;
		_data_->_tmp20_ = _data_->_tmp19_->message;
		g_warning ("UserUtils.vala:139: %s", _data_->_tmp20_);
		_data_->result = NULL;
		_g_error_free0 (_data_->e);
		__vala_JsonNode_free0 (_data_->root);
		_g_object_unref0 (_data_->call);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		__vala_JsonNode_free0 (_data_->root);
		_g_object_unref0 (_data_->call);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp21_ = _data_->root;
	_data_->_tmp22_ = json_node_get_object (_data_->_tmp21_);
	_data_->_tmp23_ = _json_object_ref0 (_data_->_tmp22_);
	_data_->root_obj = _data_->_tmp23_;
	_data_->_tmp24_ = _data_->root_obj;
	_data_->_tmp25_ = json_object_get_array_member (_data_->_tmp24_, "users");
	_data_->_tmp26_ = _json_array_ref0 (_data_->_tmp25_);
	_data_->user_array = _data_->_tmp26_;
	memset (&_data_->cursor, 0, sizeof (JsonCursor));
	_data_->_tmp27_ = _data_->root_obj;
	_data_->cursor.next_cursor = json_object_get_int_member (_data_->_tmp27_, "next_cursor");
	_data_->_tmp28_ = _data_->user_array;
	_data_->cursor.full = json_array_get_length (_data_->_tmp28_) < ((guint) requested);
	_data_->_tmp29_ = _data_->root_obj;
	_data_->_tmp30_ = json_object_get_member (_data_->_tmp29_, "users");
	_data_->_tmp31_ = __vala_JsonNode_copy0 (_data_->_tmp30_);
	__vala_JsonNode_free0 (_data_->cursor.json_object);
	_data_->cursor.json_object = _data_->_tmp31_;
	_data_->_tmp32_ = _data_->cursor;
	_data_->_tmp33_ = _json_cursor_dup0 (&_data_->_tmp32_);
	_data_->_tmp34_ = _data_->_tmp33_;
	json_cursor_destroy (&_data_->_tmp32_);
	_data_->result = _data_->_tmp34_;
	_json_array_unref0 (_data_->user_array);
	_json_object_unref0 (_data_->root_obj);
	__vala_JsonNode_free0 (_data_->root);
	_g_object_unref0 (_data_->call);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
user_utils_mute_user_data_free (gpointer _data)
{
	UserUtilsMuteUserData* _data_;
	_data_ = _data;
	g_slice_free (UserUtilsMuteUserData, _data_);
}

void
user_utils_mute_user (Account* account,
                      gint64 to_block,
                      gboolean setting,
                      GAsyncReadyCallback _callback_,
                      gpointer _user_data_)
{
	UserUtilsMuteUserData* _data_;
	Account* _tmp0_;
	_data_ = g_slice_new0 (UserUtilsMuteUserData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, user_utils_mute_user_data_free);
	_tmp0_ = _g_object_ref0 (account);
	_g_object_unref0 (_data_->account);
	_data_->account = _tmp0_;
	_data_->to_block = to_block;
	_data_->setting = setting;
	user_utils_mute_user_co (_data_);
}

void
user_utils_mute_user_finish (GAsyncResult* _res_,
                             GError** error)
{
	UserUtilsMuteUserData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return;
	}
}

static Block72Data*
block72_data_ref (Block72Data* _data72_)
{
	g_atomic_int_inc (&_data72_->_ref_count_);
	return _data72_;
}

static void
block72_data_unref (void * _userdata_)
{
	Block72Data* _data72_;
	_data72_ = (Block72Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data72_->_ref_count_)) {
		_g_error_free0 (_data72_->err);
		_g_object_unref0 (_data72_->call);
		_g_object_unref0 (_data72_->account);
		g_slice_free (Block72Data, _data72_);
	}
}

static gpointer
_g_error_copy0 (gpointer self)
{
	return self ? g_error_copy (self) : NULL;
}

static void
__lambda196_ (Block72Data* _data72_,
              GObject* obj,
              GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (res != NULL);
	{
		RestProxyCall* _tmp0_;
		_tmp0_ = _data72_->call;
		rest_proxy_call_invoke_finish (_tmp0_, res, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		if (_data72_->setting) {
			RestProxyCall* _tmp1_;
			const gchar* _tmp2_;
			_tmp1_ = _data72_->call;
			_tmp2_ = rest_proxy_call_get_payload (_tmp1_);
			tweet_utils_inject_user_mute (_tmp2_, _data72_->account);
		} else {
			RestProxyCall* _tmp3_;
			const gchar* _tmp4_;
			_tmp3_ = _data72_->call;
			_tmp4_ = rest_proxy_call_get_payload (_tmp3_);
			tweet_utils_inject_user_unmute (_tmp4_, _data72_->account);
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* tmp_err = NULL;
		RestProxyCall* _tmp5_;
		GError* _tmp6_;
		GError* _tmp7_;
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp5_ = _data72_->call;
		_tmp6_ = e;
		_tmp7_ = tweet_utils_failed_request_to_error (_tmp5_, _tmp6_);
		tmp_err = _tmp7_;
		if (_data72_->setting) {
			_tmp9_ = TRUE;
		} else {
			GError* _tmp10_;
			_tmp10_ = tmp_err;
			_tmp9_ = _tmp10_->domain != tweet_utils_get_error_domain ();
		}
		if (_tmp9_) {
			_tmp8_ = TRUE;
		} else {
			GError* _tmp11_;
			_tmp11_ = tmp_err;
			_tmp8_ = _tmp11_->code != 272;
		}
		if (_tmp8_) {
			GError* _tmp12_;
			GError* _tmp13_;
			_tmp12_ = tmp_err;
			_tmp13_ = _g_error_copy0 (_tmp12_);
			_g_error_free0 (_data72_->err);
			_data72_->err = _tmp13_;
		}
		_g_error_free0 (tmp_err);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	user_utils_mute_user_co (_data72_->_async_data_);
}

static void
___lambda196__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
	__lambda196_ (self, source_object, res);
	block72_data_unref (self);
}

static gboolean
user_utils_mute_user_co (UserUtilsMuteUserData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data72_ = g_slice_new0 (Block72Data);
	_data_->_data72_->_ref_count_ = 1;
	_g_object_unref0 (_data_->_data72_->account);
	_data_->_data72_->account = _data_->account;
	_data_->_data72_->setting = _data_->setting;
	_data_->_data72_->_async_data_ = _data_;
	_data_->_tmp0_ = _data_->_data72_->account->proxy;
	_data_->_tmp1_ = rest_proxy_new_call ((RestProxy*) _data_->_tmp0_);
	_data_->_data72_->call = _data_->_tmp1_;
	_data_->_tmp2_ = _data_->_data72_->call;
	rest_proxy_call_set_method (_data_->_tmp2_, "POST");
	if (_data_->_data72_->setting) {
		_data_->_tmp3_ = _data_->_data72_->call;
		rest_proxy_call_set_function (_data_->_tmp3_, "1.1/mutes/users/create.json");
		_data_->_tmp4_ = _data_->_data72_->call;
		rest_proxy_call_add_param (_data_->_tmp4_, "include_entities", "false");
		_data_->_tmp5_ = _data_->_data72_->call;
		rest_proxy_call_add_param (_data_->_tmp5_, "skip_status", "true");
	} else {
		_data_->_tmp6_ = _data_->_data72_->call;
		rest_proxy_call_set_function (_data_->_tmp6_, "1.1/mutes/users/destroy.json");
	}
	_data_->_tmp7_ = _data_->_data72_->call;
	_data_->_tmp8_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->to_block);
	_data_->_tmp9_ = _data_->_tmp8_;
	rest_proxy_call_add_param (_data_->_tmp7_, "user_id", _data_->_tmp9_);
	_g_free0 (_data_->_tmp9_);
	_data_->_data72_->err = NULL;
	_data_->_tmp10_ = _data_->_data72_->call;
	rest_proxy_call_invoke_async (_data_->_tmp10_, NULL, ___lambda196__gasync_ready_callback, block72_data_ref (_data_->_data72_));
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	_data_->_tmp11_ = _data_->_data72_->err;
	if (_data_->_tmp11_ != NULL) {
		_data_->_tmp12_ = _data_->_data72_->err;
		_data_->_tmp13_ = _g_error_copy0 (_data_->_tmp12_);
		_data_->_inner_error0_ = _data_->_tmp13_;
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
		block72_data_unref (_data_->_data72_);
		_data_->_data72_ = NULL;
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	block72_data_unref (_data_->_data72_);
	_data_->_data72_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
user_utils_block_user_data_free (gpointer _data)
{
	UserUtilsBlockUserData* _data_;
	_data_ = _data;
	g_slice_free (UserUtilsBlockUserData, _data_);
}

void
user_utils_block_user (Account* account,
                       gint64 to_block,
                       gboolean setting,
                       GAsyncReadyCallback _callback_,
                       gpointer _user_data_)
{
	UserUtilsBlockUserData* _data_;
	Account* _tmp0_;
	_data_ = g_slice_new0 (UserUtilsBlockUserData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, user_utils_block_user_data_free);
	_tmp0_ = _g_object_ref0 (account);
	_g_object_unref0 (_data_->account);
	_data_->account = _tmp0_;
	_data_->to_block = to_block;
	_data_->setting = setting;
	user_utils_block_user_co (_data_);
}

void
user_utils_block_user_finish (GAsyncResult* _res_,
                              GError** error)
{
	UserUtilsBlockUserData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return;
	}
}

static Block73Data*
block73_data_ref (Block73Data* _data73_)
{
	g_atomic_int_inc (&_data73_->_ref_count_);
	return _data73_;
}

static void
block73_data_unref (void * _userdata_)
{
	Block73Data* _data73_;
	_data73_ = (Block73Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data73_->_ref_count_)) {
		_g_error_free0 (_data73_->err);
		_g_object_unref0 (_data73_->call);
		_g_object_unref0 (_data73_->account);
		g_slice_free (Block73Data, _data73_);
	}
}

static void
__lambda194_ (Block73Data* _data73_,
              GObject* obj,
              GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (res != NULL);
	{
		RestProxyCall* _tmp0_;
		_tmp0_ = _data73_->call;
		rest_proxy_call_invoke_finish (_tmp0_, res, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		if (_data73_->setting) {
			RestProxyCall* _tmp1_;
			const gchar* _tmp2_;
			_tmp1_ = _data73_->call;
			_tmp2_ = rest_proxy_call_get_payload (_tmp1_);
			tweet_utils_inject_user_block (_tmp2_, _data73_->account);
		} else {
			RestProxyCall* _tmp3_;
			const gchar* _tmp4_;
			_tmp3_ = _data73_->call;
			_tmp4_ = rest_proxy_call_get_payload (_tmp3_);
			tweet_utils_inject_user_unblock (_tmp4_, _data73_->account);
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* tmp_err = NULL;
		RestProxyCall* _tmp5_;
		GError* _tmp6_;
		GError* _tmp7_;
		GError* _tmp8_;
		const gchar* _tmp9_;
		gboolean _tmp10_ = FALSE;
		gboolean _tmp11_ = FALSE;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp5_ = _data73_->call;
		_tmp6_ = e;
		_tmp7_ = tweet_utils_failed_request_to_error (_tmp5_, _tmp6_);
		tmp_err = _tmp7_;
		_tmp8_ = tmp_err;
		_tmp9_ = _tmp8_->message;
		g_debug ("UserUtils.vala:224: Error: %s", _tmp9_);
		if (_data73_->setting) {
			_tmp11_ = TRUE;
		} else {
			GError* _tmp12_;
			_tmp12_ = tmp_err;
			_tmp11_ = _tmp12_->domain != tweet_utils_get_error_domain ();
		}
		if (_tmp11_) {
			_tmp10_ = TRUE;
		} else {
			GError* _tmp13_;
			_tmp13_ = tmp_err;
			_tmp10_ = _tmp13_->code != 272;
		}
		if (_tmp10_) {
			GError* _tmp14_;
			GError* _tmp15_;
			_tmp14_ = tmp_err;
			_tmp15_ = _g_error_copy0 (_tmp14_);
			_g_error_free0 (_data73_->err);
			_data73_->err = _tmp15_;
		}
		_g_error_free0 (tmp_err);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	user_utils_block_user_co (_data73_->_async_data_);
}

static void
___lambda194__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
	__lambda194_ (self, source_object, res);
	block73_data_unref (self);
}

static gboolean
user_utils_block_user_co (UserUtilsBlockUserData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data73_ = g_slice_new0 (Block73Data);
	_data_->_data73_->_ref_count_ = 1;
	_g_object_unref0 (_data_->_data73_->account);
	_data_->_data73_->account = _data_->account;
	_data_->_data73_->setting = _data_->setting;
	_data_->_data73_->_async_data_ = _data_;
	_data_->_tmp0_ = _data_->_data73_->account->proxy;
	_data_->_tmp1_ = rest_proxy_new_call ((RestProxy*) _data_->_tmp0_);
	_data_->_data73_->call = _data_->_tmp1_;
	_data_->_tmp2_ = _data_->_data73_->call;
	rest_proxy_call_set_method (_data_->_tmp2_, "POST");
	if (_data_->_data73_->setting) {
		_data_->_tmp3_ = _data_->_data73_->call;
		rest_proxy_call_set_function (_data_->_tmp3_, "1.1/blocks/create.json");
	} else {
		_data_->_tmp4_ = _data_->_data73_->call;
		rest_proxy_call_set_function (_data_->_tmp4_, "1.1/blocks/destroy.json");
	}
	_data_->_tmp5_ = _data_->_data73_->call;
	_data_->_tmp6_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->to_block);
	_data_->_tmp7_ = _data_->_tmp6_;
	rest_proxy_call_add_param (_data_->_tmp5_, "user_id", _data_->_tmp7_);
	_g_free0 (_data_->_tmp7_);
	_data_->_tmp8_ = _data_->_data73_->call;
	rest_proxy_call_add_param (_data_->_tmp8_, "include_entities", "false");
	_data_->_tmp9_ = _data_->_data73_->call;
	rest_proxy_call_add_param (_data_->_tmp9_, "skip_status", "true");
	_data_->_data73_->err = NULL;
	_data_->_tmp10_ = _data_->_data73_->call;
	rest_proxy_call_invoke_async (_data_->_tmp10_, NULL, ___lambda194__gasync_ready_callback, block73_data_ref (_data_->_data73_));
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	_data_->_tmp11_ = _data_->_data73_->err;
	if (_data_->_tmp11_ != NULL) {
		_data_->_tmp12_ = _data_->_data73_->err;
		_data_->_tmp13_ = _g_error_copy0 (_data_->_tmp12_);
		_data_->_inner_error0_ = _data_->_tmp13_;
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
		block73_data_unref (_data_->_data73_);
		_data_->_data73_ = NULL;
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	block73_data_unref (_data_->_data73_);
	_data_->_data73_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
user_utils_load_user_timeline_by_id_data_free (gpointer _data)
{
	UserUtilsLoadUserTimelineByIdData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->account);
	_json_array_unref0 (_data_->result);
	g_slice_free (UserUtilsLoadUserTimelineByIdData, _data_);
}

void
user_utils_load_user_timeline_by_id (Account* account,
                                     gint64 user_id,
                                     gint tweet_count,
                                     gint64 since_id,
                                     gint64 max_id,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
	UserUtilsLoadUserTimelineByIdData* _data_;
	Account* _tmp0_;
	_data_ = g_slice_new0 (UserUtilsLoadUserTimelineByIdData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, user_utils_load_user_timeline_by_id_data_free);
	_tmp0_ = _g_object_ref0 (account);
	_g_object_unref0 (_data_->account);
	_data_->account = _tmp0_;
	_data_->user_id = user_id;
	_data_->tweet_count = tweet_count;
	_data_->since_id = since_id;
	_data_->max_id = max_id;
	user_utils_load_user_timeline_by_id_co (_data_);
}

JsonArray*
user_utils_load_user_timeline_by_id_finish (GAsyncResult* _res_,
                                            GError** error)
{
	JsonArray* result;
	UserUtilsLoadUserTimelineByIdData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return NULL;
	}
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static void
user_utils_load_user_timeline_by_id_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_)
{
	UserUtilsLoadUserTimelineByIdData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	user_utils_load_user_timeline_by_id_co (_data_);
}

static gboolean
user_utils_load_user_timeline_by_id_co (UserUtilsLoadUserTimelineByIdData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp1_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->user_id);
	_data_->_tmp2_ = _data_->_tmp1_;
	_data_->_state_ = 1;
	user_utils_load_user_timeline (_data_->account, "user_id", _data_->_tmp2_, _data_->tweet_count, _data_->since_id, _data_->max_id, user_utils_load_user_timeline_by_id_ready, _data_);
	return FALSE;
	_state_1:
	_data_->_tmp3_ = user_utils_load_user_timeline_finish (_data_->_res_, &_data_->_inner_error0_);
	_data_->_tmp4_ = _data_->_tmp3_;
	_g_free0 (_data_->_tmp2_);
	_data_->_tmp0_ = _data_->_tmp4_;
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp5_ = _data_->_tmp0_;
	_data_->_tmp0_ = NULL;
	_data_->result = _data_->_tmp5_;
	_json_array_unref0 (_data_->_tmp0_);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
user_utils_load_user_timeline_by_screen_name_data_free (gpointer _data)
{
	UserUtilsLoadUserTimelineByScreenNameData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->account);
	_g_free0 (_data_->screen_name);
	_json_array_unref0 (_data_->result);
	g_slice_free (UserUtilsLoadUserTimelineByScreenNameData, _data_);
}

void
user_utils_load_user_timeline_by_screen_name (Account* account,
                                              const gchar* screen_name,
                                              gint tweet_count,
                                              gint64 since_id,
                                              gint64 max_id,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	UserUtilsLoadUserTimelineByScreenNameData* _data_;
	Account* _tmp0_;
	gchar* _tmp1_;
	_data_ = g_slice_new0 (UserUtilsLoadUserTimelineByScreenNameData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, user_utils_load_user_timeline_by_screen_name_data_free);
	_tmp0_ = _g_object_ref0 (account);
	_g_object_unref0 (_data_->account);
	_data_->account = _tmp0_;
	_tmp1_ = g_strdup (screen_name);
	_g_free0 (_data_->screen_name);
	_data_->screen_name = _tmp1_;
	_data_->tweet_count = tweet_count;
	_data_->since_id = since_id;
	_data_->max_id = max_id;
	user_utils_load_user_timeline_by_screen_name_co (_data_);
}

JsonArray*
user_utils_load_user_timeline_by_screen_name_finish (GAsyncResult* _res_,
                                                     GError** error)
{
	JsonArray* result;
	UserUtilsLoadUserTimelineByScreenNameData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return NULL;
	}
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static void
user_utils_load_user_timeline_by_screen_name_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_)
{
	UserUtilsLoadUserTimelineByScreenNameData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	user_utils_load_user_timeline_by_screen_name_co (_data_);
}

static gboolean
user_utils_load_user_timeline_by_screen_name_co (UserUtilsLoadUserTimelineByScreenNameData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_state_ = 1;
	user_utils_load_user_timeline (_data_->account, "screen_name", _data_->screen_name, _data_->tweet_count, _data_->since_id, _data_->max_id, user_utils_load_user_timeline_by_screen_name_ready, _data_);
	return FALSE;
	_state_1:
	_data_->_tmp1_ = user_utils_load_user_timeline_finish (_data_->_res_, &_data_->_inner_error0_);
	_data_->_tmp0_ = _data_->_tmp1_;
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp2_ = _data_->_tmp0_;
	_data_->_tmp0_ = NULL;
	_data_->result = _data_->_tmp2_;
	_json_array_unref0 (_data_->_tmp0_);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
user_utils_load_user_timeline_data_free (gpointer _data)
{
	UserUtilsLoadUserTimelineData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->account);
	_g_free0 (_data_->field);
	_g_free0 (_data_->value);
	_json_array_unref0 (_data_->result);
	g_slice_free (UserUtilsLoadUserTimelineData, _data_);
}

void
user_utils_load_user_timeline (Account* account,
                               const gchar* field,
                               const gchar* value,
                               gint tweet_count,
                               gint64 since_id,
                               gint64 max_id,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	UserUtilsLoadUserTimelineData* _data_;
	Account* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	_data_ = g_slice_new0 (UserUtilsLoadUserTimelineData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, user_utils_load_user_timeline_data_free);
	_tmp0_ = _g_object_ref0 (account);
	_g_object_unref0 (_data_->account);
	_data_->account = _tmp0_;
	_tmp1_ = g_strdup (field);
	_g_free0 (_data_->field);
	_data_->field = _tmp1_;
	_tmp2_ = g_strdup (value);
	_g_free0 (_data_->value);
	_data_->value = _tmp2_;
	_data_->tweet_count = tweet_count;
	_data_->since_id = since_id;
	_data_->max_id = max_id;
	user_utils_load_user_timeline_co (_data_);
}

JsonArray*
user_utils_load_user_timeline_finish (GAsyncResult* _res_,
                                      GError** error)
{
	JsonArray* result;
	UserUtilsLoadUserTimelineData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return NULL;
	}
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static void
user_utils_load_user_timeline_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_)
{
	UserUtilsLoadUserTimelineData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	user_utils_load_user_timeline_co (_data_);
}

static gboolean
user_utils_load_user_timeline_co (UserUtilsLoadUserTimelineData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->account->proxy;
	_data_->_tmp1_ = rest_proxy_new_call ((RestProxy*) _data_->_tmp0_);
	_data_->call = _data_->_tmp1_;
	_data_->_tmp2_ = _data_->call;
	rest_proxy_call_set_function (_data_->_tmp2_, "1.1/statuses/user_timeline.json");
	_data_->_tmp3_ = _data_->call;
	rest_proxy_call_set_method (_data_->_tmp3_, "GET");
	_data_->_tmp4_ = _data_->call;
	rest_proxy_call_add_param (_data_->_tmp4_, _data_->field, _data_->value);
	if (_data_->since_id > ((gint64) 0)) {
		_data_->_tmp5_ = _data_->call;
		_data_->_tmp6_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->since_id);
		_data_->_tmp7_ = _data_->_tmp6_;
		rest_proxy_call_add_param (_data_->_tmp5_, "since_id", _data_->_tmp7_);
		_g_free0 (_data_->_tmp7_);
	}
	if (_data_->max_id > ((gint64) 0)) {
		_data_->_tmp8_ = _data_->call;
		_data_->_tmp9_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->max_id);
		_data_->_tmp10_ = _data_->_tmp9_;
		rest_proxy_call_add_param (_data_->_tmp8_, "max_id", _data_->_tmp10_);
		_g_free0 (_data_->_tmp10_);
	}
	_data_->_tmp11_ = _data_->call;
	_data_->_tmp12_ = g_strdup_printf ("%i", _data_->tweet_count);
	_data_->_tmp13_ = _data_->_tmp12_;
	rest_proxy_call_add_param (_data_->_tmp11_, "count", _data_->_tmp13_);
	_g_free0 (_data_->_tmp13_);
	_data_->_tmp14_ = _data_->call;
	rest_proxy_call_add_param (_data_->_tmp14_, "contributor_details", "true");
	_data_->_tmp15_ = _data_->call;
	rest_proxy_call_add_param (_data_->_tmp15_, "tweet_mode", "extended");
	_data_->_tmp16_ = _data_->call;
	rest_proxy_call_add_param (_data_->_tmp16_, "include_my_retweet", "true");
	_data_->_tmp17_ = _data_->call;
	rest_proxy_call_add_param (_data_->_tmp17_, "include_ext_alt_text", "true");
	_data_->root = NULL;
	_data_->array = NULL;
	{
		_data_->_tmp19_ = _data_->call;
		_data_->_state_ = 1;
		cb_utils_load_threaded_async (_data_->_tmp19_, NULL, user_utils_load_user_timeline_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp20_ = cb_utils_load_threaded_finish (_data_->_res_, &_data_->_inner_error0_);
		_data_->_tmp18_ = _data_->_tmp20_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->_tmp21_ = _data_->_tmp18_;
		_data_->_tmp18_ = NULL;
		__vala_JsonNode_free0 (_data_->root);
		_data_->root = _data_->_tmp21_;
		_data_->_tmp22_ = _data_->root;
		if (_data_->_tmp22_ != NULL) {
			_data_->_tmp23_ = _data_->root;
			_data_->_tmp24_ = json_node_get_array (_data_->_tmp23_);
			_data_->_tmp25_ = _json_array_ref0 (_data_->_tmp24_);
			_json_array_unref0 (_data_->array);
			_data_->array = _data_->_tmp25_;
		}
		__vala_JsonNode_free0 (_data_->_tmp18_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp27_ = _data_->e;
		if (_data_->_tmp27_->domain == rest_proxy_error_quark ()) {
			_data_->_tmp28_ = _data_->e;
			_data_->_tmp29_ = g_error_new_literal (REST_PROXY_ERROR, REST_PROXY_ERROR_SSL, "workaround");
			_data_->_tmp30_ = _data_->_tmp29_;
			_data_->_tmp26_ = _data_->_tmp28_->code == _data_->_tmp30_->code;
			_g_error_free0 (_data_->_tmp30_);
		} else {
			_data_->_tmp26_ = FALSE;
		}
		if (_data_->_tmp26_) {
			g_debug ("UserUtils.vala:274: Reloading user timeline on SSL failure");
			_data_->_state_ = 2;
			user_utils_load_user_timeline (_data_->account, _data_->field, _data_->value, _data_->tweet_count, _data_->since_id, _data_->max_id, user_utils_load_user_timeline_ready, _data_);
			return FALSE;
			_state_2:
			_data_->_tmp32_ = user_utils_load_user_timeline_finish (_data_->_res_, &_data_->_inner_error0_);
			_data_->_tmp31_ = _data_->_tmp32_;
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				_g_error_free0 (_data_->e);
				goto __finally0;
			}
			_data_->_tmp33_ = _data_->_tmp31_;
			_data_->_tmp31_ = NULL;
			_json_array_unref0 (_data_->array);
			_data_->array = _data_->_tmp33_;
			_json_array_unref0 (_data_->_tmp31_);
		} else {
			_data_->_tmp34_ = _data_->e;
			_data_->_tmp35_ = _g_error_copy0 (_data_->_tmp34_);
			_data_->_inner_error0_ = _data_->_tmp35_;
			_g_error_free0 (_data_->e);
			goto __finally0;
		}
		_g_error_free0 (_data_->e);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
		_json_array_unref0 (_data_->array);
		__vala_JsonNode_free0 (_data_->root);
		_g_object_unref0 (_data_->call);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp37_ = _data_->array;
	_data_->_tmp38_ = _json_array_ref0 (_data_->_tmp37_);
	_data_->_tmp36_ = _data_->_tmp38_;
	if (_data_->_tmp36_ == NULL) {
		_data_->_tmp39_ = json_array_new ();
		_json_array_unref0 (_data_->_tmp36_);
		_data_->_tmp36_ = _data_->_tmp39_;
	}
	_data_->_tmp40_ = _data_->_tmp36_;
	_data_->_tmp36_ = NULL;
	_data_->result = _data_->_tmp40_;
	_json_array_unref0 (_data_->_tmp36_);
	_json_array_unref0 (_data_->array);
	__vala_JsonNode_free0 (_data_->root);
	_g_object_unref0 (_data_->call);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

