/* ListBox.c generated by valac 0.48.13, the Vala compiler
 * generated from ListBox.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <pango/pango.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#define TYPE_LIST_BOX (list_box_get_type ())
#define LIST_BOX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIST_BOX, ListBox))
#define LIST_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIST_BOX, ListBoxClass))
#define IS_LIST_BOX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIST_BOX))
#define IS_LIST_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIST_BOX))
#define LIST_BOX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIST_BOX, ListBoxClass))

typedef struct _ListBox ListBox;
typedef struct _ListBoxClass ListBoxClass;
typedef struct _ListBoxPrivate ListBoxPrivate;
enum  {
	LIST_BOX_0_PROPERTY,
	LIST_BOX_NUM_PROPERTIES
};
static GParamSpec* list_box_properties[LIST_BOX_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	LIST_BOX_RETRY_BUTTON_CLICKED_SIGNAL,
	LIST_BOX_NUM_SIGNALS
};
static guint list_box_signals[LIST_BOX_NUM_SIGNALS] = {0};

struct _ListBox {
	GtkListBox parent_instance;
	ListBoxPrivate * priv;
};

struct _ListBoxClass {
	GtkListBoxClass parent_class;
};

struct _ListBoxPrivate {
	GtkStack* placeholder;
	GtkLabel* no_entries_label;
	GtkBox* error_box;
	GtkLabel* error_label;
	GtkButton* retry_button;
};

static gint ListBox_private_offset;
static gpointer list_box_parent_class = NULL;

GType list_box_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ListBox, g_object_unref)
ListBox* list_box_new (void);
ListBox* list_box_construct (GType object_type);
static void list_box_add_placeholder (ListBox* self);
static void __lambda34_ (ListBox* self);
static void ___lambda34__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
void list_box_set_empty (ListBox* self);
void list_box_set_unempty (ListBox* self);
void list_box_set_error (ListBox* self,
                         const gchar* err_msg);
GtkStack* list_box_get_placeholder (ListBox* self);
void list_box_set_placeholder_text (ListBox* self,
                                    const gchar* text);
void list_box_reset_placeholder_text (ListBox* self);
void list_box_remove_all (ListBox* self);
static void __lambda35_ (ListBox* self,
                  GtkWidget* w);
static void ___lambda35__gtk_callback (GtkWidget* widget,
                                gpointer self);
GtkWidget* list_box_get_first_visible_row (ListBox* self);
GtkWidget* list_box_get_last_visible_row (ListBox* self);
static GObject * list_box_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties);
GSettings* settings_get (void);
static void list_box_finalize (GObject * obj);
static GType list_box_get_type_once (void);

static inline gpointer
list_box_get_instance_private (ListBox* self)
{
	return G_STRUCT_MEMBER_P (self, ListBox_private_offset);
}

ListBox*
list_box_construct (GType object_type)
{
	ListBox * self = NULL;
	self = (ListBox*) g_object_new (object_type, NULL);
	return self;
}

ListBox*
list_box_new (void)
{
	return list_box_construct (TYPE_LIST_BOX);
}

static void
__lambda34_ (ListBox* self)
{
	GtkStack* _tmp0_;
	_tmp0_ = self->priv->placeholder;
	gtk_stack_set_visible_child_name (_tmp0_, "spinner");
	g_signal_emit (self, list_box_signals[LIST_BOX_RETRY_BUTTON_CLICKED_SIGNAL], 0);
}

static void
___lambda34__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
	__lambda34_ ((ListBox*) self);
}

static void
list_box_add_placeholder (ListBox* self)
{
	GtkStack* _tmp0_;
	GtkStack* _tmp1_;
	GtkLabel* loading_label = NULL;
	GtkLabel* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkStack* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkStyleContext* _tmp7_;
	GtkLabel* _tmp8_;
	GtkStack* _tmp9_;
	GtkLabel* _tmp10_;
	GtkBox* _tmp11_;
	GtkLabel* _tmp12_;
	GtkLabel* _tmp13_;
	GtkStyleContext* _tmp14_;
	GtkLabel* _tmp15_;
	GtkLabel* _tmp16_;
	GtkLabel* _tmp17_;
	GtkButton* _tmp18_;
	GtkButton* _tmp19_;
	GtkButton* _tmp20_;
	GtkBox* _tmp21_;
	GtkLabel* _tmp22_;
	GtkBox* _tmp23_;
	GtkButton* _tmp24_;
	GtkStack* _tmp25_;
	GtkBox* _tmp26_;
	GtkStack* _tmp27_;
	GtkStack* _tmp28_;
	GtkStack* _tmp29_;
	GtkStack* _tmp30_;
	GtkStack* _tmp31_;
	g_return_if_fail (self != NULL);
	_tmp0_ = (GtkStack*) gtk_stack_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->placeholder);
	self->priv->placeholder = _tmp0_;
	_tmp1_ = self->priv->placeholder;
	gtk_stack_set_transition_type (_tmp1_, GTK_STACK_TRANSITION_TYPE_CROSSFADE);
	_tmp2_ = (GtkLabel*) gtk_label_new (_ ("Loading…"));
	g_object_ref_sink (_tmp2_);
	loading_label = _tmp2_;
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) loading_label);
	gtk_style_context_add_class (_tmp3_, "dim-label");
	_tmp4_ = self->priv->placeholder;
	gtk_stack_add_named (_tmp4_, (GtkWidget*) loading_label, "spinner");
	_tmp5_ = (GtkLabel*) gtk_label_new (_ ("No entries found"));
	g_object_ref_sink (_tmp5_);
	_g_object_unref0 (self->priv->no_entries_label);
	self->priv->no_entries_label = _tmp5_;
	_tmp6_ = self->priv->no_entries_label;
	_tmp7_ = gtk_widget_get_style_context ((GtkWidget*) _tmp6_);
	gtk_style_context_add_class (_tmp7_, "dim-label");
	_tmp8_ = self->priv->no_entries_label;
	g_object_set (_tmp8_, "wrap-mode", PANGO_WRAP_WORD_CHAR, NULL);
	_tmp9_ = self->priv->placeholder;
	_tmp10_ = self->priv->no_entries_label;
	gtk_stack_add_named (_tmp9_, (GtkWidget*) _tmp10_, "no-entries");
	_tmp11_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 12);
	g_object_ref_sink (_tmp11_);
	_g_object_unref0 (self->priv->error_box);
	self->priv->error_box = _tmp11_;
	_tmp12_ = (GtkLabel*) gtk_label_new ("");
	g_object_ref_sink (_tmp12_);
	_g_object_unref0 (self->priv->error_label);
	self->priv->error_label = _tmp12_;
	_tmp13_ = self->priv->error_label;
	_tmp14_ = gtk_widget_get_style_context ((GtkWidget*) _tmp13_);
	gtk_style_context_add_class (_tmp14_, "dim-label");
	_tmp15_ = self->priv->error_label;
	g_object_set ((GtkWidget*) _tmp15_, "margin", 12, NULL);
	_tmp16_ = self->priv->error_label;
	gtk_label_set_selectable (_tmp16_, TRUE);
	_tmp17_ = self->priv->error_label;
	g_object_set (_tmp17_, "wrap", TRUE, NULL);
	_tmp18_ = (GtkButton*) gtk_button_new_with_label (_ ("Retry"));
	g_object_ref_sink (_tmp18_);
	_g_object_unref0 (self->priv->retry_button);
	self->priv->retry_button = _tmp18_;
	_tmp19_ = self->priv->retry_button;
	gtk_widget_set_halign ((GtkWidget*) _tmp19_, GTK_ALIGN_CENTER);
	_tmp20_ = self->priv->retry_button;
	g_signal_connect_object (_tmp20_, "clicked", (GCallback) ___lambda34__gtk_button_clicked, self, 0);
	_tmp21_ = self->priv->error_box;
	_tmp22_ = self->priv->error_label;
	gtk_container_add ((GtkContainer*) _tmp21_, (GtkWidget*) _tmp22_);
	_tmp23_ = self->priv->error_box;
	_tmp24_ = self->priv->retry_button;
	gtk_container_add ((GtkContainer*) _tmp23_, (GtkWidget*) _tmp24_);
	_tmp25_ = self->priv->placeholder;
	_tmp26_ = self->priv->error_box;
	gtk_stack_add_named (_tmp25_, (GtkWidget*) _tmp26_, "error");
	_tmp27_ = self->priv->placeholder;
	gtk_stack_set_visible_child_name (_tmp27_, "spinner");
	_tmp28_ = self->priv->placeholder;
	gtk_widget_show_all ((GtkWidget*) _tmp28_);
	_tmp29_ = self->priv->placeholder;
	gtk_widget_set_valign ((GtkWidget*) _tmp29_, GTK_ALIGN_CENTER);
	_tmp30_ = self->priv->placeholder;
	gtk_widget_set_halign ((GtkWidget*) _tmp30_, GTK_ALIGN_CENTER);
	_tmp31_ = self->priv->placeholder;
	gtk_list_box_set_placeholder ((GtkListBox*) self, (GtkWidget*) _tmp31_);
	_g_object_unref0 (loading_label);
}

void
list_box_set_empty (ListBox* self)
{
	GtkStack* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->placeholder;
	gtk_stack_set_visible_child_name (_tmp0_, "no-entries");
}

void
list_box_set_unempty (ListBox* self)
{
	GtkStack* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->placeholder;
	gtk_stack_set_visible_child_name (_tmp0_, "spinner");
}

void
list_box_set_error (ListBox* self,
                    const gchar* err_msg)
{
	GtkLabel* _tmp0_;
	GtkStack* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (err_msg != NULL);
	_tmp0_ = self->priv->error_label;
	gtk_label_set_label (_tmp0_, err_msg);
	_tmp1_ = self->priv->placeholder;
	gtk_stack_set_visible_child_name (_tmp1_, "error");
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

GtkStack*
list_box_get_placeholder (ListBox* self)
{
	GtkStack* _tmp0_;
	GtkStack* _tmp1_;
	GtkStack* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->placeholder;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}

void
list_box_set_placeholder_text (ListBox* self,
                               const gchar* text)
{
	GtkLabel* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (text != NULL);
	_tmp0_ = self->priv->no_entries_label;
	gtk_label_set_label (_tmp0_, text);
}

void
list_box_reset_placeholder_text (ListBox* self)
{
	GtkLabel* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->no_entries_label;
	gtk_label_set_label (_tmp0_, _ ("No entries found"));
}

static void
__lambda35_ (ListBox* self,
             GtkWidget* w)
{
	g_return_if_fail (w != NULL);
	gtk_container_remove ((GtkContainer*) self, w);
}

static void
___lambda35__gtk_callback (GtkWidget* widget,
                           gpointer self)
{
	__lambda35_ ((ListBox*) self, widget);
}

void
list_box_remove_all (ListBox* self)
{
	g_return_if_fail (self != NULL);
	gtk_container_foreach ((GtkContainer*) self, ___lambda35__gtk_callback, self);
}

GtkWidget*
list_box_get_first_visible_row (ListBox* self)
{
	gint i = 0;
	GtkWidget* row = NULL;
	GtkListBoxRow* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	i = 0;
	_tmp0_ = gtk_list_box_get_row_at_index ((GtkListBox*) self, 0);
	_tmp1_ = _g_object_ref0 ((GtkWidget*) _tmp0_);
	row = _tmp1_;
	while (TRUE) {
		gboolean _tmp2_ = FALSE;
		GtkWidget* _tmp3_;
		gint _tmp7_;
		GtkListBoxRow* _tmp8_;
		GtkWidget* _tmp9_;
		_tmp3_ = row;
		if (_tmp3_ != NULL) {
			GtkWidget* _tmp4_;
			gboolean _tmp5_;
			gboolean _tmp6_;
			_tmp4_ = row;
			_tmp5_ = gtk_widget_get_visible (_tmp4_);
			_tmp6_ = _tmp5_;
			_tmp2_ = !_tmp6_;
		} else {
			_tmp2_ = FALSE;
		}
		if (!_tmp2_) {
			break;
		}
		_tmp7_ = i;
		i = _tmp7_ + 1;
		_tmp8_ = gtk_list_box_get_row_at_index ((GtkListBox*) self, i);
		_tmp9_ = _g_object_ref0 ((GtkWidget*) _tmp8_);
		_g_object_unref0 (row);
		row = _tmp9_;
	}
	result = row;
	return result;
}

GtkWidget*
list_box_get_last_visible_row (ListBox* self)
{
	gint i = 0;
	GList* _tmp0_;
	GList* _tmp1_;
	gint _tmp2_;
	GtkWidget* row = NULL;
	GtkListBoxRow* _tmp3_;
	GtkWidget* _tmp4_;
	GtkWidget* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gtk_container_get_children ((GtkContainer*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = ((gint) g_list_length (_tmp1_)) - 1;
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_list_free (_tmp1_), NULL));
	i = _tmp2_;
	_tmp3_ = gtk_list_box_get_row_at_index ((GtkListBox*) self, i);
	_tmp4_ = _g_object_ref0 ((GtkWidget*) _tmp3_);
	row = _tmp4_;
	while (TRUE) {
		gboolean _tmp5_ = FALSE;
		GtkWidget* _tmp6_;
		gint _tmp10_;
		GtkListBoxRow* _tmp11_;
		GtkWidget* _tmp12_;
		_tmp6_ = row;
		if (_tmp6_ != NULL) {
			GtkWidget* _tmp7_;
			gboolean _tmp8_;
			gboolean _tmp9_;
			_tmp7_ = row;
			_tmp8_ = gtk_widget_get_visible (_tmp7_);
			_tmp9_ = _tmp8_;
			_tmp5_ = !_tmp9_;
		} else {
			_tmp5_ = FALSE;
		}
		if (!_tmp5_) {
			break;
		}
		_tmp10_ = i;
		i = _tmp10_ - 1;
		_tmp11_ = gtk_list_box_get_row_at_index ((GtkListBox*) self, i);
		_tmp12_ = _g_object_ref0 ((GtkWidget*) _tmp11_);
		_g_object_unref0 (row);
		row = _tmp12_;
	}
	result = row;
	return result;
}

static GObject *
list_box_constructor (GType type,
                      guint n_construct_properties,
                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ListBox * self;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	parent_class = G_OBJECT_CLASS (list_box_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIST_BOX, ListBox);
	list_box_add_placeholder (self);
	gtk_list_box_set_selection_mode ((GtkListBox*) self, GTK_SELECTION_NONE);
	_tmp0_ = settings_get ();
	_tmp1_ = _tmp0_;
	g_settings_bind (_tmp1_, "double-click-activation", (GObject*) self, "activate-on-single-click", G_SETTINGS_BIND_INVERT_BOOLEAN);
	_g_object_unref0 (_tmp1_);
	return obj;
}

static void
list_box_class_init (ListBoxClass * klass,
                     gpointer klass_data)
{
	list_box_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ListBox_private_offset);
	G_OBJECT_CLASS (klass)->constructor = list_box_constructor;
	G_OBJECT_CLASS (klass)->finalize = list_box_finalize;
	list_box_signals[LIST_BOX_RETRY_BUTTON_CLICKED_SIGNAL] = g_signal_new ("retry-button-clicked", TYPE_LIST_BOX, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
list_box_instance_init (ListBox * self,
                        gpointer klass)
{
	self->priv = list_box_get_instance_private (self);
	self->priv->placeholder = NULL;
}

static void
list_box_finalize (GObject * obj)
{
	ListBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIST_BOX, ListBox);
	_g_object_unref0 (self->priv->placeholder);
	_g_object_unref0 (self->priv->no_entries_label);
	_g_object_unref0 (self->priv->error_box);
	_g_object_unref0 (self->priv->error_label);
	_g_object_unref0 (self->priv->retry_button);
	G_OBJECT_CLASS (list_box_parent_class)->finalize (obj);
}

static GType
list_box_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ListBoxClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) list_box_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ListBox), 0, (GInstanceInitFunc) list_box_instance_init, NULL };
	GType list_box_type_id;
	list_box_type_id = g_type_register_static (gtk_list_box_get_type (), "ListBox", &g_define_type_info, 0);
	ListBox_private_offset = g_type_add_instance_private (list_box_type_id, sizeof (ListBoxPrivate));
	return list_box_type_id;
}

GType
list_box_get_type (void)
{
	static volatile gsize list_box_type_id__volatile = 0;
	if (g_once_init_enter (&list_box_type_id__volatile)) {
		GType list_box_type_id;
		list_box_type_id = list_box_get_type_once ();
		g_once_init_leave (&list_box_type_id__volatile, list_box_type_id);
	}
	return list_box_type_id__volatile;
}

