/* MediaButton.c generated by valac 0.48.13, the Vala compiler
 * generated from MediaButton.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include "CbMedia.h"
#include <gio/gio.h>
#include <pango/pango.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <cairo-gobject.h>
#include <glib/gi18n-lib.h>
#include "CbMediaDownloader.h"
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <stdlib.h>
#include <string.h>
#include <atk/atk.h>

#define TYPE_MEDIA_BUTTON (media_button_get_type ())
#define MEDIA_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_BUTTON, MediaButton))
#define MEDIA_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_BUTTON, MediaButtonClass))
#define IS_MEDIA_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_BUTTON))
#define IS_MEDIA_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_BUTTON))
#define MEDIA_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_BUTTON, MediaButtonClass))

typedef struct _MediaButton MediaButton;
typedef struct _MediaButtonClass MediaButtonClass;
typedef struct _MediaButtonPrivate MediaButtonPrivate;
enum  {
	MEDIA_BUTTON_0_PROPERTY,
	MEDIA_BUTTON_MEDIA_PROPERTY,
	MEDIA_BUTTON_NUM_PROPERTIES
};
static GParamSpec* media_button_properties[MEDIA_BUTTON_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block84Data Block84Data;
#define __vala_GdkEvent_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkEvent_free (var), NULL)))
#define __vala_GdkEventSequence_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkEventSequence_free (var), NULL)))
enum  {
	MEDIA_BUTTON_CLICKED_SIGNAL,
	MEDIA_BUTTON_NUM_SIGNALS
};
static guint media_button_signals[MEDIA_BUTTON_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _MediaButton {
	GtkBin parent_instance;
	MediaButtonPrivate * priv;
	GtkWindow* window;
};

struct _MediaButtonClass {
	GtkBinClass parent_class;
};

struct _MediaButtonPrivate {
	GdkWindow* event_window;
	CbMedia* _media;
	GMenu* menu_model;
	GtkMenu* menu;
	GSimpleActionGroup* actions;
	PangoLayout* layout;
	GtkGestureMultiPress* press_gesture;
	gboolean restrict_height;
	gint64 fade_start_time;
	gdouble media_alpha;
};

struct _Block84Data {
	int _ref_count_;
	MediaButton* self;
	gchar* url;
};

static gint MediaButton_private_offset;
static gpointer media_button_parent_class = NULL;
static cairo_surface_t** media_button_play_icons;
static gint media_button_play_icons_length1;
static cairo_surface_t** media_button_play_icons = NULL;
static gint media_button_play_icons_length1 = 0;
static gint _media_button_play_icons_size_ = 0;

GType media_button_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaButton, g_object_unref)
static void media_button_media_progress_cb (MediaButton* self);
static void _media_button_media_progress_cb_cb_media_progress (CbMedia* _sender,
                                                        gpointer self);
#define MEDIA_BUTTON_PLAY_ICON_SIZE 32
#define MEDIA_BUTTON_MAX_HEIGHT 200
#define MEDIA_BUTTON_MIN_HEIGHT 40
#define MEDIA_BUTTON_MIN_WIDTH 40
static void media_button_copy_url_activated (MediaButton* self,
                                      GSimpleAction* a,
                                      GVariant* v);
static void _media_button_copy_url_activated_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self);
static void media_button_open_in_browser_activated (MediaButton* self,
                                             GSimpleAction* a,
                                             GVariant* v);
static void _media_button_open_in_browser_activated_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self);
static void media_button_save_as_activated (MediaButton* self,
                                     GSimpleAction* a,
                                     GVariant* v);
static void _media_button_save_as_activated_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self);
MediaButton* media_button_new (CbMedia* media,
                               gboolean restrict_height);
MediaButton* media_button_construct (GType object_type,
                                     CbMedia* media,
                                     gboolean restrict_height);
void media_button_set_media (MediaButton* self,
                             CbMedia* value);
static void media_button_gesture_released_cb (MediaButton* self,
                                       gint n_press,
                                       gdouble x,
                                       gdouble y);
static void _media_button_gesture_released_cb_gtk_gesture_multi_press_released (GtkGestureMultiPress* _sender,
                                                                         gint n_press,
                                                                         gdouble x,
                                                                         gdouble y,
                                                                         gpointer self);
static void media_button_gesture_pressed_cb (MediaButton* self,
                                      gint n_press,
                                      gdouble x,
                                      gdouble y);
static void _media_button_gesture_pressed_cb_gtk_gesture_multi_press_pressed (GtkGestureMultiPress* _sender,
                                                                       gint n_press,
                                                                       gdouble x,
                                                                       gdouble y,
                                                                       gpointer self);
gboolean utils_set_pointer_on_mouseover (GdkEventCrossing* event);
static gboolean _utils_set_pointer_on_mouseover_gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                                        GdkEventCrossing* event,
                                                                        gpointer self);
static gboolean _utils_set_pointer_on_mouseover_gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                                        GdkEventCrossing* event,
                                                                        gpointer self);
static void media_button_set_image_description (MediaButton* self);
static void media_button_reload_image (MediaButton* self);
CbMedia* media_button_get_media (MediaButton* self);
static void media_button_start_fade (MediaButton* self);
static void media_button_set_save_as_sensitivity (MediaButton* self);
static gboolean media_button_fade_in_cb (MediaButton* self,
                                  GtkWidget* widget,
                                  GdkFrameClock* frame_clock);
#define TRANSITION_DURATION (200 * 1000)
gdouble ease_out_cubic (gdouble t);
static gboolean _media_button_fade_in_cb_gtk_tick_callback (GtkWidget* widget,
                                                     GdkFrameClock* frame_clock,
                                                     gpointer self);
static gboolean media_button_real_draw (GtkWidget* base,
                                 cairo_t* ct);
void utils_calculate_draw_offset (gint img_width,
                                  gint img_height,
                                  gint widget_width,
                                  gint widget_height,
                                  gint* draw_x,
                                  gint* draw_y,
                                  gdouble* scale);
gchar* utils_get_media_display_name (CbMedia* media);
static Block84Data* block84_data_ref (Block84Data* _data84_);
static void block84_data_unref (void * _userdata_);
void utils_show_error_dialog (GError* e,
                              GtkWindow* transient_for,
                              const gchar* file,
                              gint line);
void utils_download_file (const gchar* url,
                          GOutputStream* out_stream,
                          GAsyncReadyCallback _callback_,
                          gpointer _user_data_);
void utils_download_file_finish (GAsyncResult* _res_);
static void ____lambda14_ (Block84Data* _data84_);
static void _____lambda14__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static GtkSizeRequestMode media_button_real_get_request_mode (GtkWidget* base);
static void media_button_real_get_preferred_height (GtkWidget* base,
                                             gint* minimum,
                                             gint* natural);
static void media_button_real_get_preferred_height_for_width (GtkWidget* base,
                                                       gint width,
                                                       gint* minimum,
                                                       gint* natural);
static void media_button_real_get_preferred_width_for_height (GtkWidget* base,
                                                       gint height,
                                                       gint* minimum,
                                                       gint* natural);
static void media_button_real_get_preferred_width (GtkWidget* base,
                                            gint* minimum,
                                            gint* natural);
static void media_button_real_realize (GtkWidget* base);
static void media_button_real_unrealize (GtkWidget* base);
static void media_button_real_map (GtkWidget* base);
static void media_button_real_unmap (GtkWidget* base);
static void media_button_real_size_allocate (GtkWidget* base,
                                      GtkAllocation* alloc);
static gboolean media_button_real_enter_notify_event (GtkWidget* base,
                                               GdkEventCrossing* evt);
static gboolean media_button_real_leave_notify_event (GtkWidget* base,
                                               GdkEventCrossing* evt);
static GdkEvent* _vala_GdkEvent_copy (GdkEvent* self);
static void _vala_GdkEvent_free (GdkEvent* self);
static void _vala_GdkEventSequence_free (GdkEventSequence* self);
static gboolean media_button_real_key_press_event (GtkWidget* base,
                                            GdkEventKey* event);
static gboolean media_button_get_is_m3u8 (MediaButton* self);
static void g_cclosure_user_marshal_VOID__OBJECT_DOUBLE_DOUBLE (GClosure * closure,
                                                         GValue * return_value,
                                                         guint n_param_values,
                                                         const GValue * param_values,
                                                         gpointer invocation_hint,
                                                         gpointer marshal_data);
static GObject * media_button_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static void media_button_finalize (GObject * obj);
static GType media_button_get_type_once (void);
static void _vala_media_button_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_media_button_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static const GActionEntry MEDIA_BUTTON_action_entries[3] = {{"copy-url", _media_button_copy_url_activated_gsimple_action_activate_callback}, {"open-in-browser", _media_button_open_in_browser_activated_gsimple_action_activate_callback}, {"save-as", _media_button_save_as_activated_gsimple_action_activate_callback}};

static inline gpointer
media_button_get_instance_private (MediaButton* self)
{
	return G_STRUCT_MEMBER_P (self, MediaButton_private_offset);
}

static void
_media_button_media_progress_cb_cb_media_progress (CbMedia* _sender,
                                                   gpointer self)
{
	media_button_media_progress_cb ((MediaButton*) self);
}

static void
_media_button_copy_url_activated_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self)
{
	media_button_copy_url_activated ((MediaButton*) self, action, parameter);
}

static void
_media_button_open_in_browser_activated_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self)
{
	media_button_open_in_browser_activated ((MediaButton*) self, action, parameter);
}

static void
_media_button_save_as_activated_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self)
{
	media_button_save_as_activated ((MediaButton*) self, action, parameter);
}

static void
_media_button_gesture_released_cb_gtk_gesture_multi_press_released (GtkGestureMultiPress* _sender,
                                                                    gint n_press,
                                                                    gdouble x,
                                                                    gdouble y,
                                                                    gpointer self)
{
	media_button_gesture_released_cb ((MediaButton*) self, n_press, x, y);
}

static void
_media_button_gesture_pressed_cb_gtk_gesture_multi_press_pressed (GtkGestureMultiPress* _sender,
                                                                  gint n_press,
                                                                  gdouble x,
                                                                  gdouble y,
                                                                  gpointer self)
{
	media_button_gesture_pressed_cb ((MediaButton*) self, n_press, x, y);
}

static gboolean
_utils_set_pointer_on_mouseover_gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                               GdkEventCrossing* event,
                                                               gpointer self)
{
	gboolean result;
	result = utils_set_pointer_on_mouseover (event);
	return result;
}

static gboolean
_utils_set_pointer_on_mouseover_gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                               GdkEventCrossing* event,
                                                               gpointer self)
{
	gboolean result;
	result = utils_set_pointer_on_mouseover (event);
	return result;
}

MediaButton*
media_button_construct (GType object_type,
                        CbMedia* media,
                        gboolean restrict_height)
{
	MediaButton * self = NULL;
	GtkButton* reload_button = NULL;
	GtkButton* _tmp0_;
	GtkStyleContext* _tmp1_;
	GSimpleActionGroup* _tmp2_;
	GSimpleActionGroup* _tmp3_;
	GSimpleActionGroup* _tmp4_;
	GMenu* _tmp5_;
	GMenu* _tmp6_;
	GMenu* _tmp7_;
	PangoLayout* _tmp8_;
	GtkGestureMultiPress* _tmp9_;
	GtkGestureMultiPress* _tmp10_;
	GtkGestureMultiPress* _tmp11_;
	GtkGestureMultiPress* _tmp12_;
	GtkGestureMultiPress* _tmp13_;
	GtkGestureMultiPress* _tmp14_;
	self = (MediaButton*) g_object_new (object_type, NULL);
	self->priv->restrict_height = restrict_height;
	_tmp0_ = (GtkButton*) gtk_button_new ();
	g_object_ref_sink (_tmp0_);
	reload_button = _tmp0_;
	gtk_button_set_label (reload_button, _ ("Reload image"));
	gtk_widget_set_halign ((GtkWidget*) reload_button, GTK_ALIGN_CENTER);
	gtk_widget_set_valign ((GtkWidget*) reload_button, GTK_ALIGN_CENTER);
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) reload_button);
	gtk_widget_show ((GtkWidget*) reload_button);
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp1_, "inline-media");
	_tmp2_ = g_simple_action_group_new ();
	_g_object_unref0 (self->priv->actions);
	self->priv->actions = _tmp2_;
	_tmp3_ = self->priv->actions;
	g_action_map_add_action_entries ((GActionMap*) _tmp3_, MEDIA_BUTTON_action_entries, (gint) G_N_ELEMENTS (MEDIA_BUTTON_action_entries), self);
	_tmp4_ = self->priv->actions;
	gtk_widget_insert_action_group ((GtkWidget*) self, "media", (GActionGroup*) _tmp4_);
	_tmp5_ = g_menu_new ();
	_g_object_unref0 (self->priv->menu_model);
	self->priv->menu_model = _tmp5_;
	_tmp6_ = self->priv->menu_model;
	g_menu_append (_tmp6_, _ ("Open in Browser"), "media.open-in-browser");
	_tmp7_ = self->priv->menu_model;
	g_menu_append (_tmp7_, _ ("Save as…"), "media.save-as");
	media_button_set_media (self, media);
	_tmp8_ = gtk_widget_create_pango_layout ((GtkWidget*) self, "0%");
	_g_object_unref0 (self->priv->layout);
	self->priv->layout = _tmp8_;
	_tmp9_ = (GtkGestureMultiPress*) gtk_gesture_multi_press_new ((GtkWidget*) self);
	_g_object_unref0 (self->priv->press_gesture);
	self->priv->press_gesture = _tmp9_;
	_tmp10_ = self->priv->press_gesture;
	gtk_gesture_single_set_exclusive ((GtkGestureSingle*) _tmp10_, TRUE);
	_tmp11_ = self->priv->press_gesture;
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp11_, (guint) 0);
	_tmp12_ = self->priv->press_gesture;
	gtk_event_controller_set_propagation_phase ((GtkEventController*) _tmp12_, GTK_PHASE_CAPTURE);
	_tmp13_ = self->priv->press_gesture;
	g_signal_connect_object (_tmp13_, "released", (GCallback) _media_button_gesture_released_cb_gtk_gesture_multi_press_released, self, 0);
	_tmp14_ = self->priv->press_gesture;
	g_signal_connect_object (_tmp14_, "pressed", (GCallback) _media_button_gesture_pressed_cb_gtk_gesture_multi_press_pressed, self, 0);
	g_signal_connect ((GtkWidget*) self, "enter-notify-event", (GCallback) _utils_set_pointer_on_mouseover_gtk_widget_enter_notify_event, NULL);
	g_signal_connect ((GtkWidget*) self, "leave-notify-event", (GCallback) _utils_set_pointer_on_mouseover_gtk_widget_leave_notify_event, NULL);
	media_button_set_image_description (self);
	_g_object_unref0 (reload_button);
	return self;
}

MediaButton*
media_button_new (CbMedia* media,
                  gboolean restrict_height)
{
	return media_button_construct (TYPE_MEDIA_BUTTON, media, restrict_height);
}

static void
media_button_reload_image (MediaButton* self)
{
	CbMediaDownloader* _tmp0_;
	CbMedia* _tmp1_;
	CbMedia* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = cb_media_downloader_get_default ();
	_tmp1_ = media_button_get_media (self);
	_tmp2_ = _tmp1_;
	cb_media_downloader_reload_async (_tmp0_, _tmp2_, NULL, NULL);
}

static void
media_button_media_progress_cb (MediaButton* self)
{
	CbMedia* _tmp0_;
	g_return_if_fail (self != NULL);
	gtk_widget_queue_draw ((GtkWidget*) self);
	_tmp0_ = self->priv->_media;
	if (_tmp0_->loaded) {
		gboolean _tmp1_ = FALSE;
		CbMedia* _tmp2_;
		_tmp2_ = self->priv->_media;
		if (!_tmp2_->invalid) {
			CbMedia* _tmp3_;
			cairo_surface_t* _tmp4_;
			_tmp3_ = self->priv->_media;
			_tmp4_ = _tmp3_->surface;
			_tmp1_ = _tmp4_ != NULL;
		} else {
			_tmp1_ = FALSE;
		}
		if (_tmp1_) {
			media_button_start_fade (self);
		}
		media_button_set_save_as_sensitivity (self);
		gtk_widget_queue_resize ((GtkWidget*) self);
	}
}

static gboolean
media_button_fade_in_cb (MediaButton* self,
                         GtkWidget* widget,
                         GdkFrameClock* frame_clock)
{
	gint64 now = 0LL;
	gdouble t = 0.0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (frame_clock != NULL, FALSE);
	if (!gtk_widget_get_mapped ((GtkWidget*) self)) {
		self->priv->media_alpha = 1.0;
		result = G_SOURCE_REMOVE;
		return result;
	}
	now = gdk_frame_clock_get_frame_time (frame_clock);
	t = 1.0;
	if (now < (self->priv->fade_start_time + TRANSITION_DURATION)) {
		t = (now - self->priv->fade_start_time) / ((gdouble) TRANSITION_DURATION);
	}
	t = ease_out_cubic (t);
	self->priv->media_alpha = t;
	gtk_widget_queue_draw ((GtkWidget*) self);
	if (t >= 1.0) {
		self->priv->media_alpha = 1.0;
		result = G_SOURCE_REMOVE;
		return result;
	}
	result = G_SOURCE_CONTINUE;
	return result;
}

static gboolean
_media_button_fade_in_cb_gtk_tick_callback (GtkWidget* widget,
                                            GdkFrameClock* frame_clock,
                                            gpointer self)
{
	gboolean result;
	result = media_button_fade_in_cb ((MediaButton*) self, widget, frame_clock);
	return result;
}

static void
media_button_start_fade (MediaButton* self)
{
	CbMedia* _tmp0_;
	CbMedia* _tmp1_;
	CbMedia* _tmp2_;
	CbMedia* _tmp3_;
	cairo_surface_t* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	GdkFrameClock* _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp0_ = media_button_get_media (self);
	_tmp1_ = _tmp0_;
	_vala_assert (_tmp1_ != NULL, "this.media != null");
	_tmp2_ = media_button_get_media (self);
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_->surface;
	_vala_assert (_tmp4_ != NULL, "this.media.surface != null");
	if (!gtk_widget_get_realized ((GtkWidget*) self)) {
		_tmp6_ = TRUE;
	} else {
		_tmp6_ = !gtk_widget_get_mapped ((GtkWidget*) self);
	}
	if (_tmp6_) {
		_tmp5_ = TRUE;
	} else {
		GtkSettings* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
		_tmp7_ = gtk_settings_get_default ();
		g_object_get (_tmp7_, "gtk-enable-animations", &_tmp8_, NULL);
		_tmp9_ = _tmp8_;
		_tmp5_ = !_tmp9_;
	}
	if (_tmp5_) {
		self->priv->media_alpha = 1.0;
		return;
	}
	_tmp10_ = gtk_widget_get_frame_clock ((GtkWidget*) self);
	self->priv->fade_start_time = gdk_frame_clock_get_frame_time (_tmp10_);
	gtk_widget_add_tick_callback ((GtkWidget*) self, _media_button_fade_in_cb_gtk_tick_callback, g_object_ref (self), g_object_unref);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gboolean
media_button_real_draw (GtkWidget* base,
                        cairo_t* ct)
{
	MediaButton * self;
	gint widget_width = 0;
	gint widget_height = 0;
	gboolean _tmp0_ = FALSE;
	CbMedia* _tmp1_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
	self = (MediaButton*) base;
	g_return_val_if_fail (ct != NULL, FALSE);
	widget_width = gtk_widget_get_allocated_width ((GtkWidget*) self);
	widget_height = gtk_widget_get_allocated_height ((GtkWidget*) self);
	_tmp1_ = self->priv->_media;
	if (_tmp1_ != NULL) {
		CbMedia* _tmp2_;
		_tmp2_ = self->priv->_media;
		_tmp0_ = _tmp2_->invalid;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GTK_WIDGET_CLASS (media_button_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_bin_get_type (), GtkBin), ct);
	} else {
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
		CbMedia* _tmp5_;
		_tmp5_ = self->priv->_media;
		if (_tmp5_ != NULL) {
			CbMedia* _tmp6_;
			cairo_surface_t* _tmp7_;
			_tmp6_ = self->priv->_media;
			_tmp7_ = _tmp6_->surface;
			_tmp4_ = _tmp7_ != NULL;
		} else {
			_tmp4_ = FALSE;
		}
		if (_tmp4_) {
			CbMedia* _tmp8_;
			_tmp8_ = self->priv->_media;
			_tmp3_ = _tmp8_->loaded;
		} else {
			_tmp3_ = FALSE;
		}
		if (_tmp3_) {
			gint draw_x = 0;
			gint draw_y = 0;
			gdouble scale = 0.0;
			CbMedia* _tmp9_;
			CbMedia* _tmp10_;
			gint _tmp11_ = 0;
			gint _tmp12_ = 0;
			gdouble _tmp13_ = 0.0;
			gint draw_width = 0;
			gint draw_height = 0;
			CbMedia* _tmp14_;
			CbMedia* _tmp15_;
			cairo_surface_t* _tmp16_;
			CbMedia* _tmp23_;
			gboolean _tmp27_ = FALSE;
			CbMedia* _tmp28_;
			CbMedia* _tmp29_;
			const gchar* _tmp30_;
			GtkStyleContext* sc = NULL;
			GtkStyleContext* _tmp44_;
			GtkStyleContext* _tmp45_;
			GtkStyleContext* _tmp46_;
			GtkStyleContext* _tmp47_;
			_tmp9_ = self->priv->_media;
			_tmp10_ = self->priv->_media;
			utils_calculate_draw_offset (_tmp9_->thumb_width, _tmp10_->thumb_height, gtk_widget_get_allocated_width ((GtkWidget*) self), gtk_widget_get_allocated_height ((GtkWidget*) self), &_tmp11_, &_tmp12_, &_tmp13_);
			draw_x = _tmp11_;
			draw_y = _tmp12_;
			scale = _tmp13_;
			draw_width = gtk_widget_get_allocated_width ((GtkWidget*) self) - draw_x;
			draw_height = gtk_widget_get_allocated_height ((GtkWidget*) self) - draw_y;
			cairo_save (ct);
			cairo_rectangle (ct, (gdouble) 0, (gdouble) 0, (gdouble) widget_width, (gdouble) widget_height);
			cairo_scale (ct, scale, scale);
			_tmp14_ = media_button_get_media (self);
			_tmp15_ = _tmp14_;
			_tmp16_ = _tmp15_->surface;
			cairo_set_source_surface (ct, _tmp16_, draw_x / scale, draw_y / scale);
			cairo_paint_with_alpha (ct, self->priv->media_alpha);
			cairo_restore (ct);
			cairo_new_path (ct);
			if (draw_y < 0) {
				cairo_pattern_t* pattern = NULL;
				cairo_pattern_t* _tmp17_;
				cairo_pattern_t* _tmp18_;
				cairo_pattern_t* _tmp19_;
				cairo_pattern_t* _tmp20_;
				cairo_pattern_t* _tmp21_;
				cairo_pattern_t* _tmp22_;
				_tmp17_ = cairo_pattern_create_linear (0.0, 0.0, (gdouble) 0, (gdouble) widget_height);
				pattern = _tmp17_;
				_tmp18_ = pattern;
				cairo_pattern_add_color_stop_rgba (_tmp18_, 0.01, 0.3, 0.3, 0.3, (gdouble) 1);
				_tmp19_ = pattern;
				cairo_pattern_add_color_stop_rgba (_tmp19_, 0.1, 0.7, 0.7, 0.7, (gdouble) 0);
				_tmp20_ = pattern;
				cairo_pattern_add_color_stop_rgba (_tmp20_, 0.9, 0.7, 0.7, 0.7, (gdouble) 0);
				_tmp21_ = pattern;
				cairo_pattern_add_color_stop_rgba (_tmp21_, 0.99, 0.3, 0.3, 0.3, (gdouble) 1);
				cairo_rectangle (ct, (gdouble) 0, (gdouble) 0, (gdouble) widget_width, (gdouble) widget_height);
				_tmp22_ = pattern;
				cairo_set_source (ct, _tmp22_);
				cairo_fill (ct);
				_cairo_pattern_destroy0 (pattern);
			}
			_tmp23_ = self->priv->_media;
			if (cb_media_is_video (_tmp23_)) {
				gint x = 0;
				gint y = 0;
				gint _tmp24_ = 0;
				cairo_surface_t** _tmp25_;
				gint _tmp25__length1;
				cairo_surface_t* _tmp26_;
				x = (widget_width / 2) - (MEDIA_BUTTON_PLAY_ICON_SIZE / 2);
				y = (widget_height / 2) - (MEDIA_BUTTON_PLAY_ICON_SIZE / 2);
				cairo_save (ct);
				cairo_rectangle (ct, (gdouble) x, (gdouble) y, (gdouble) MEDIA_BUTTON_PLAY_ICON_SIZE, (gdouble) MEDIA_BUTTON_PLAY_ICON_SIZE);
				if (gtk_widget_get_scale_factor ((GtkWidget*) self) == 1) {
					_tmp24_ = 0;
				} else {
					_tmp24_ = 1;
				}
				_tmp25_ = media_button_play_icons;
				_tmp25__length1 = media_button_play_icons_length1;
				_tmp26_ = _tmp25_[_tmp24_];
				cairo_set_source_surface (ct, _tmp26_, (gdouble) x, (gdouble) y);
				cairo_paint_with_alpha (ct, self->priv->media_alpha);
				cairo_restore (ct);
				cairo_new_path (ct);
			}
			_tmp28_ = media_button_get_media (self);
			_tmp29_ = _tmp28_;
			_tmp30_ = _tmp29_->alt_text;
			if (_tmp30_ != NULL) {
				CbMedia* _tmp31_;
				CbMedia* _tmp32_;
				const gchar* _tmp33_;
				_tmp31_ = media_button_get_media (self);
				_tmp32_ = _tmp31_;
				_tmp33_ = _tmp32_->alt_text;
				_tmp27_ = g_strcmp0 (_tmp33_, "") != 0;
			} else {
				_tmp27_ = FALSE;
			}
			if (_tmp27_) {
				GtkIconTheme* icon_theme = NULL;
				GtkIconTheme* _tmp34_;
				GtkIconTheme* _tmp35_;
				gint icon_size = 0;
				_tmp34_ = gtk_icon_theme_get_default ();
				_tmp35_ = _g_object_ref0 (_tmp34_);
				icon_theme = _tmp35_;
				icon_size = 24;
				{
					GdkPixbuf* pixbuf = NULL;
					GtkIconTheme* _tmp36_;
					GdkPixbuf* _tmp37_;
					cairo_surface_t* icon = NULL;
					GdkPixbuf* _tmp38_;
					cairo_surface_t* _tmp39_;
					cairo_surface_t* _tmp40_;
					_tmp36_ = icon_theme;
					_tmp37_ = gtk_icon_theme_load_icon_for_scale (_tmp36_, "dialog-information", icon_size, gtk_widget_get_scale_factor ((GtkWidget*) self), GTK_ICON_LOOKUP_USE_BUILTIN, &_inner_error0_);
					pixbuf = _tmp37_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						goto __catch0_g_error;
					}
					_tmp38_ = pixbuf;
					_tmp39_ = gdk_cairo_surface_create_from_pixbuf (_tmp38_, gtk_widget_get_scale_factor ((GtkWidget*) self), NULL);
					icon = _tmp39_;
					_tmp40_ = icon;
					cairo_set_source_surface (ct, _tmp40_, draw_x / scale, (gdouble) (widget_height - (icon_size * gtk_widget_get_scale_factor ((GtkWidget*) self))));
					cairo_paint (ct);
					_cairo_surface_destroy0 (icon);
					_g_object_unref0 (pixbuf);
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					GError* _tmp41_;
					const gchar* _tmp42_;
					e = _inner_error0_;
					_inner_error0_ = NULL;
					_tmp41_ = e;
					_tmp42_ = _tmp41_->message;
					g_warning ("MediaButton.vala:246: %s", _tmp42_);
					_g_error_free0 (e);
				}
				__finally0:
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					gboolean _tmp43_ = FALSE;
					_g_object_unref0 (icon_theme);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return _tmp43_;
				}
				_g_object_unref0 (icon_theme);
			}
			_tmp44_ = gtk_widget_get_style_context ((GtkWidget*) self);
			_tmp45_ = _g_object_ref0 (_tmp44_);
			sc = _tmp45_;
			_tmp46_ = sc;
			gtk_render_background (_tmp46_, ct, (gdouble) draw_x, (gdouble) 0, (gdouble) draw_width, (gdouble) draw_height);
			_tmp47_ = sc;
			gtk_render_frame (_tmp47_, ct, (gdouble) draw_x, (gdouble) 0, (gdouble) draw_width, (gdouble) draw_height);
			if (gtk_widget_has_visible_focus ((GtkWidget*) self)) {
				GtkStyleContext* _tmp48_;
				_tmp48_ = sc;
				gtk_render_focus (_tmp48_, ct, (gdouble) (draw_x + 2), (gdouble) 2, (gdouble) (draw_width - 4), (gdouble) (draw_height - 4));
			}
			_g_object_unref0 (sc);
		} else {
			GtkStyleContext* sc = NULL;
			GtkStyleContext* _tmp49_;
			GtkStyleContext* _tmp50_;
			gdouble layout_x = 0.0;
			gdouble layout_y = 0.0;
			gint layout_w = 0;
			gint layout_h = 0;
			PangoLayout* _tmp51_;
			CbMedia* _tmp52_;
			gchar* _tmp53_;
			gchar* _tmp54_;
			PangoLayout* _tmp55_;
			gint _tmp56_ = 0;
			gint _tmp57_ = 0;
			GtkStyleContext* _tmp58_;
			PangoLayout* _tmp59_;
			_tmp49_ = gtk_widget_get_style_context ((GtkWidget*) self);
			_tmp50_ = _g_object_ref0 (_tmp49_);
			sc = _tmp50_;
			_tmp51_ = self->priv->layout;
			_tmp52_ = self->priv->_media;
			_tmp53_ = g_strdup_printf ("%d%%", (gint) (_tmp52_->percent_loaded * 100));
			_tmp54_ = _tmp53_;
			pango_layout_set_text (_tmp51_, _tmp54_, -1);
			_g_free0 (_tmp54_);
			_tmp55_ = self->priv->layout;
			pango_layout_get_size (_tmp55_, &_tmp56_, &_tmp57_);
			layout_w = _tmp56_;
			layout_h = _tmp57_;
			layout_x = (widget_width / 2.0) - ((layout_w / PANGO_SCALE) / 2.0);
			layout_y = (widget_height / 2.0) - ((layout_h / PANGO_SCALE) / 2.0);
			_tmp58_ = sc;
			_tmp59_ = self->priv->layout;
			gtk_render_layout (_tmp58_, ct, layout_x, layout_y, _tmp59_);
			_g_object_unref0 (sc);
		}
	}
	result = GDK_EVENT_PROPAGATE;
	return result;
}

static void
media_button_copy_url_activated (MediaButton* self,
                                 GSimpleAction* a,
                                 GVariant* v)
{
	GtkClipboard* clipboard = NULL;
	GdkDisplay* _tmp0_;
	GtkClipboard* _tmp1_;
	GtkClipboard* _tmp2_;
	CbMedia* _tmp3_;
	CbMedia* _tmp4_;
	const gchar* _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (a != NULL);
	_tmp0_ = gdk_display_get_default ();
	_tmp1_ = gtk_clipboard_get_for_display (_tmp0_, GDK_SELECTION_CLIPBOARD);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	clipboard = _tmp2_;
	_tmp3_ = media_button_get_media (self);
	_tmp4_ = _tmp3_;
	_tmp5_ = _tmp4_->url;
	gtk_clipboard_set_text (clipboard, _tmp5_, -1);
	_g_object_unref0 (clipboard);
}

static void
media_button_open_in_browser_activated (MediaButton* self,
                                        GSimpleAction* a,
                                        GVariant* v)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (a != NULL);
	{
		const gchar* _tmp0_ = NULL;
		CbMedia* _tmp1_;
		CbMedia* _tmp2_;
		const gchar* _tmp3_;
		GtkWidget* _tmp7_;
		_tmp1_ = media_button_get_media (self);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_->target_url;
		_tmp0_ = _tmp3_;
		if (_tmp0_ == NULL) {
			CbMedia* _tmp4_;
			CbMedia* _tmp5_;
			const gchar* _tmp6_;
			_tmp4_ = media_button_get_media (self);
			_tmp5_ = _tmp4_;
			_tmp6_ = _tmp5_->url;
			_tmp0_ = _tmp6_;
		}
		_tmp7_ = gtk_widget_get_toplevel ((GtkWidget*) self);
		gtk_show_uri_on_window (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_window_get_type (), GtkWindow), _tmp0_, gtk_get_current_event_time (), &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp8_ = e;
		_tmp9_ = _tmp8_->message;
		g_critical ("MediaButton.vala:281: %s", _tmp9_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static Block84Data*
block84_data_ref (Block84Data* _data84_)
{
	g_atomic_int_inc (&_data84_->_ref_count_);
	return _data84_;
}

static void
block84_data_unref (void * _userdata_)
{
	Block84Data* _data84_;
	_data84_ = (Block84Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data84_->_ref_count_)) {
		MediaButton* self;
		self = _data84_->self;
		_g_free0 (_data84_->url);
		_g_object_unref0 (self);
		g_slice_free (Block84Data, _data84_);
	}
}

static void
____lambda14_ (Block84Data* _data84_)
{
	MediaButton* self;
	const gchar* _tmp0_;
	self = _data84_->self;
	_tmp0_ = _data84_->url;
	g_debug ("MediaButton.vala:315: Download of %s finished", _tmp0_);
}

static void
_____lambda14__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
	____lambda14_ (self);
	block84_data_unref (self);
}

static void
media_button_save_as_activated (MediaButton* self,
                                GSimpleAction* a,
                                GVariant* v)
{
	gchar* title = NULL;
	CbMedia* _tmp0_;
	GtkFileChooserNative* filechooser = NULL;
	const gchar* _tmp3_;
	GtkWindow* _tmp4_;
	GtkFileChooserNative* _tmp5_;
	GtkFileChooserNative* _tmp6_;
	CbMedia* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GtkFileChooserNative* _tmp10_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (a != NULL);
	_tmp0_ = self->priv->_media;
	if (cb_media_is_video (_tmp0_)) {
		gchar* _tmp1_;
		_tmp1_ = g_strdup (_ ("Save Video"));
		_g_free0 (title);
		title = _tmp1_;
	} else {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (_ ("Save Image"));
		_g_free0 (title);
		title = _tmp2_;
	}
	_tmp3_ = title;
	_tmp4_ = self->window;
	_tmp5_ = gtk_file_chooser_native_new (_tmp3_, _tmp4_, GTK_FILE_CHOOSER_ACTION_SAVE, _ ("Save"), _ ("Cancel"));
	filechooser = _tmp5_;
	_tmp6_ = filechooser;
	_tmp7_ = self->priv->_media;
	_tmp8_ = utils_get_media_display_name (_tmp7_);
	_tmp9_ = _tmp8_;
	gtk_file_chooser_set_current_name ((GtkFileChooser*) _tmp6_, _tmp9_);
	_g_free0 (_tmp9_);
	_tmp10_ = filechooser;
	if (gtk_native_dialog_run ((GtkNativeDialog*) _tmp10_) == ((gint) GTK_RESPONSE_ACCEPT)) {
		Block84Data* _data84_;
		GFile* file = NULL;
		GtkFileChooserNative* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		GFile* _tmp14_;
		GFile* _tmp15_;
		const gchar* _tmp16_ = NULL;
		CbMedia* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp21_;
		const gchar* _tmp22_;
		GtkFileChooserNative* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		GOutputStream* out_stream = NULL;
		GOutputStream* _tmp34_;
		_data84_ = g_slice_new0 (Block84Data);
		_data84_->_ref_count_ = 1;
		_data84_->self = g_object_ref (self);
		_tmp11_ = filechooser;
		_tmp12_ = gtk_file_chooser_get_filename ((GtkFileChooser*) _tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = g_file_new_for_path (_tmp13_);
		_tmp15_ = _tmp14_;
		_g_free0 (_tmp13_);
		file = _tmp15_;
		_tmp17_ = self->priv->_media;
		_tmp18_ = _tmp17_->target_url;
		_tmp16_ = _tmp18_;
		if (_tmp16_ == NULL) {
			CbMedia* _tmp19_;
			const gchar* _tmp20_;
			_tmp19_ = self->priv->_media;
			_tmp20_ = _tmp19_->url;
			_tmp16_ = _tmp20_;
		}
		_tmp21_ = g_strdup (_tmp16_);
		_data84_->url = _tmp21_;
		_tmp22_ = _data84_->url;
		_tmp23_ = filechooser;
		_tmp24_ = gtk_file_chooser_get_filename ((GtkFileChooser*) _tmp23_);
		_tmp25_ = _tmp24_;
		g_debug ("MediaButton.vala:303: Downloading %s to %s", _tmp22_, _tmp25_);
		_g_free0 (_tmp25_);
		out_stream = NULL;
		{
			GFileOutputStream* _tmp26_ = NULL;
			GFile* _tmp27_;
			GFileOutputStream* _tmp28_;
			GFileOutputStream* _tmp29_;
			_tmp27_ = file;
			_tmp28_ = g_file_create (_tmp27_, 0, NULL, &_inner_error0_);
			_tmp26_ = _tmp28_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
			_tmp29_ = _tmp26_;
			_tmp26_ = NULL;
			_g_object_unref0 (out_stream);
			out_stream = (GOutputStream*) _tmp29_;
			_g_object_unref0 (_tmp26_);
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp30_;
			GtkWindow* _tmp31_;
			GError* _tmp32_;
			const gchar* _tmp33_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp30_ = e;
			_tmp31_ = self->window;
			utils_show_error_dialog (_tmp30_, _tmp31_, NULL, 0);
			_tmp32_ = e;
			_tmp33_ = _tmp32_->message;
			g_warning ("MediaButton.vala:310: %s", _tmp33_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (out_stream);
			_g_object_unref0 (file);
			block84_data_unref (_data84_);
			_data84_ = NULL;
			_g_object_unref0 (filechooser);
			_g_free0 (title);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_tmp34_ = out_stream;
		if (_tmp34_ != NULL) {
			const gchar* _tmp35_;
			GOutputStream* _tmp36_;
			_tmp35_ = _data84_->url;
			_tmp36_ = out_stream;
			utils_download_file (_tmp35_, _tmp36_, _____lambda14__gasync_ready_callback, block84_data_ref (_data84_));
		}
		_g_object_unref0 (out_stream);
		_g_object_unref0 (file);
		block84_data_unref (_data84_);
		_data84_ = NULL;
	}
	_g_object_unref0 (filechooser);
	_g_free0 (title);
}

static GtkSizeRequestMode
media_button_real_get_request_mode (GtkWidget* base)
{
	MediaButton * self;
	GtkSizeRequestMode result = 0;
	self = (MediaButton*) base;
	result = GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH;
	return result;
}

static void
media_button_real_get_preferred_height (GtkWidget* base,
                                        gint* minimum,
                                        gint* natural)
{
	MediaButton * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint media_height = 0;
	gboolean _tmp0_ = FALSE;
	CbMedia* _tmp1_;
	self = (MediaButton*) base;
	_tmp1_ = self->priv->_media;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		CbMedia* _tmp2_;
		_tmp2_ = self->priv->_media;
		_tmp0_ = _tmp2_->thumb_height == -1;
	}
	if (_tmp0_) {
		media_height = 1;
	} else {
		CbMedia* _tmp3_;
		_tmp3_ = self->priv->_media;
		media_height = _tmp3_->thumb_height;
	}
	if (self->priv->restrict_height) {
		_vala_minimum = MIN (media_height, MEDIA_BUTTON_MAX_HEIGHT);
	} else {
		_vala_minimum = media_height;
	}
	_vala_natural = media_height;
	if (minimum) {
		*minimum = _vala_minimum;
	}
	if (natural) {
		*natural = _vala_natural;
	}
}

static void
media_button_real_get_preferred_height_for_width (GtkWidget* base,
                                                  gint width,
                                                  gint* minimum,
                                                  gint* natural)
{
	MediaButton * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint media_width = 0;
	gint media_height = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	CbMedia* _tmp2_;
	gdouble scale = 0.0;
	gint height = 0;
	self = (MediaButton*) base;
	_tmp2_ = self->priv->_media;
	if (_tmp2_ == NULL) {
		_tmp1_ = TRUE;
	} else {
		CbMedia* _tmp3_;
		_tmp3_ = self->priv->_media;
		_tmp1_ = _tmp3_->thumb_width == -1;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		CbMedia* _tmp4_;
		_tmp4_ = self->priv->_media;
		_tmp0_ = _tmp4_->thumb_height == -1;
	}
	if (_tmp0_) {
		media_width = MEDIA_BUTTON_MIN_WIDTH;
		media_height = MEDIA_BUTTON_MAX_HEIGHT;
	} else {
		CbMedia* _tmp5_;
		CbMedia* _tmp6_;
		_tmp5_ = self->priv->_media;
		media_width = _tmp5_->thumb_width;
		_tmp6_ = self->priv->_media;
		media_height = _tmp6_->thumb_height;
	}
	scale = width / ((gdouble) media_width);
	height = 0;
	if (scale >= ((gdouble) 1)) {
		height = MIN (media_height, (gint) floor ((width / 9.0) * 16));
	} else {
		height = (gint) floor (MIN (media_height * scale, ((media_width * scale) / 9.0) * 16));
	}
	if (self->priv->restrict_height) {
		height = MIN (height, MEDIA_BUTTON_MAX_HEIGHT);
	}
	_vala_natural = height;
	_vala_minimum = _vala_natural;
	if (minimum) {
		*minimum = _vala_minimum;
	}
	if (natural) {
		*natural = _vala_natural;
	}
}

static void
media_button_real_get_preferred_width_for_height (GtkWidget* base,
                                                  gint height,
                                                  gint* minimum,
                                                  gint* natural)
{
	MediaButton * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint media_width = 0;
	gint media_height = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	CbMedia* _tmp2_;
	gint max_width = 0;
	gint width = 0;
	self = (MediaButton*) base;
	_tmp2_ = self->priv->_media;
	if (_tmp2_ == NULL) {
		_tmp1_ = TRUE;
	} else {
		CbMedia* _tmp3_;
		_tmp3_ = self->priv->_media;
		_tmp1_ = _tmp3_->thumb_width == -1;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		CbMedia* _tmp4_;
		_tmp4_ = self->priv->_media;
		_tmp0_ = _tmp4_->thumb_height == -1;
	}
	if (_tmp0_) {
		media_width = MEDIA_BUTTON_MIN_WIDTH;
		media_height = MEDIA_BUTTON_MAX_HEIGHT;
	} else {
		CbMedia* _tmp5_;
		CbMedia* _tmp6_;
		_tmp5_ = self->priv->_media;
		media_width = _tmp5_->thumb_width;
		_tmp6_ = self->priv->_media;
		media_height = _tmp6_->thumb_height;
	}
	max_width = (gint) floor ((height / 16.0) * 9);
	width = MIN (media_width, max_width);
	_vala_minimum = MEDIA_BUTTON_MIN_WIDTH;
	_vala_natural = MAX (width, _vala_minimum);
	if (minimum) {
		*minimum = _vala_minimum;
	}
	if (natural) {
		*natural = _vala_natural;
	}
}

static void
media_button_real_get_preferred_width (GtkWidget* base,
                                       gint* minimum,
                                       gint* natural)
{
	MediaButton * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint media_width = 0;
	gboolean _tmp0_ = FALSE;
	CbMedia* _tmp1_;
	self = (MediaButton*) base;
	_tmp1_ = self->priv->_media;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		CbMedia* _tmp2_;
		_tmp2_ = self->priv->_media;
		_tmp0_ = _tmp2_->thumb_width == -1;
	}
	if (_tmp0_) {
		media_width = 1;
	} else {
		CbMedia* _tmp3_;
		_tmp3_ = self->priv->_media;
		media_width = _tmp3_->thumb_width;
	}
	_vala_minimum = MIN (media_width, MEDIA_BUTTON_MIN_WIDTH);
	_vala_natural = media_width;
	if (minimum) {
		*minimum = _vala_minimum;
	}
	if (natural) {
		*natural = _vala_natural;
	}
}

static void
media_button_real_realize (GtkWidget* base)
{
	MediaButton * self;
	GdkWindowAttr attr = {0};
	GdkWindowAttr _tmp0_ = {0};
	GdkVisual* _tmp1_;
	GdkWindowAttributesType attr_mask = 0U;
	GdkWindow* window = NULL;
	GdkWindow* _tmp2_;
	GdkWindow* _tmp3_;
	GdkWindow* _tmp4_;
	GdkWindowAttr _tmp5_;
	GdkWindow* _tmp6_;
	GdkWindow* _tmp7_;
	self = (MediaButton*) base;
	gtk_widget_set_realized ((GtkWidget*) self, TRUE);
	attr = _tmp0_;
	attr.x = 0;
	attr.y = 0;
	attr.width = gtk_widget_get_allocated_width ((GtkWidget*) self);
	attr.height = gtk_widget_get_allocated_height ((GtkWidget*) self);
	attr.window_type = GDK_WINDOW_CHILD;
	_tmp1_ = gtk_widget_get_visual ((GtkWidget*) self);
	attr.visual = _tmp1_;
	attr.wclass = GDK_INPUT_ONLY;
	attr.event_mask = ((((gtk_widget_get_events ((GtkWidget*) self) | GDK_BUTTON_PRESS_MASK) | GDK_BUTTON_RELEASE_MASK) | GDK_TOUCH_MASK) | GDK_ENTER_NOTIFY_MASK) | GDK_LEAVE_NOTIFY_MASK;
	attr_mask = GDK_WA_X | GDK_WA_Y;
	_tmp2_ = gtk_widget_get_parent_window ((GtkWidget*) self);
	_tmp3_ = _g_object_ref0 (_tmp2_);
	window = _tmp3_;
	_tmp4_ = _g_object_ref0 (window);
	gtk_widget_set_window ((GtkWidget*) self, _tmp4_);
	g_object_ref ((GObject*) window);
	_tmp5_ = attr;
	_tmp6_ = gdk_window_new (window, &_tmp5_, attr_mask);
	_g_object_unref0 (self->priv->event_window);
	self->priv->event_window = _tmp6_;
	_tmp7_ = self->priv->event_window;
	gtk_widget_register_window ((GtkWidget*) self, _tmp7_);
	_g_object_unref0 (window);
}

static void
media_button_real_unrealize (GtkWidget* base)
{
	MediaButton * self;
	GdkWindow* _tmp0_;
	self = (MediaButton*) base;
	_tmp0_ = self->priv->event_window;
	if (_tmp0_ != NULL) {
		GdkWindow* _tmp1_;
		GdkWindow* _tmp2_;
		GdkWindow* _tmp3_;
		_tmp1_ = self->priv->event_window;
		gtk_widget_unregister_window ((GtkWidget*) self, _tmp1_);
		_tmp2_ = self->priv->event_window;
		_tmp3_ = _g_object_ref0 (_tmp2_);
		gdk_window_destroy (_tmp3_);
		_g_object_unref0 (self->priv->event_window);
		self->priv->event_window = NULL;
	}
	GTK_WIDGET_CLASS (media_button_parent_class)->unrealize ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_bin_get_type (), GtkBin));
}

static void
media_button_real_map (GtkWidget* base)
{
	MediaButton * self;
	GdkWindow* _tmp0_;
	self = (MediaButton*) base;
	GTK_WIDGET_CLASS (media_button_parent_class)->map ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_bin_get_type (), GtkBin));
	_tmp0_ = self->priv->event_window;
	if (_tmp0_ != NULL) {
		GdkWindow* _tmp1_;
		_tmp1_ = self->priv->event_window;
		gdk_window_show (_tmp1_);
	}
}

static void
media_button_real_unmap (GtkWidget* base)
{
	MediaButton * self;
	GdkWindow* _tmp0_;
	self = (MediaButton*) base;
	_tmp0_ = self->priv->event_window;
	if (_tmp0_ != NULL) {
		GdkWindow* _tmp1_;
		_tmp1_ = self->priv->event_window;
		gdk_window_hide (_tmp1_);
	}
	GTK_WIDGET_CLASS (media_button_parent_class)->unmap ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_bin_get_type (), GtkBin));
}

static void
media_button_real_size_allocate (GtkWidget* base,
                                 GtkAllocation* alloc)
{
	MediaButton * self;
	GtkAllocation _tmp0_;
	self = (MediaButton*) base;
	g_return_if_fail (alloc != NULL);
	_tmp0_ = *alloc;
	GTK_WIDGET_CLASS (media_button_parent_class)->size_allocate ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_bin_get_type (), GtkBin), &_tmp0_);
	if (gtk_widget_get_realized ((GtkWidget*) self)) {
		gint draw_x = 0;
		gint draw_y = 0;
		gdouble scale = 0.0;
		CbMedia* _tmp1_;
		CbMedia* _tmp2_;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		gdouble _tmp5_ = 0.0;
		gint draw_width = 0;
		GtkAllocation _tmp6_;
		gint draw_height = 0;
		GtkAllocation _tmp7_;
		GdkWindow* _tmp8_;
		GtkAllocation _tmp9_;
		GtkAllocation _tmp10_;
		_tmp1_ = self->priv->_media;
		_tmp2_ = self->priv->_media;
		utils_calculate_draw_offset (_tmp1_->thumb_width, _tmp2_->thumb_height, gtk_widget_get_allocated_width ((GtkWidget*) self), gtk_widget_get_allocated_height ((GtkWidget*) self), &_tmp3_, &_tmp4_, &_tmp5_);
		draw_x = _tmp3_;
		draw_y = _tmp4_;
		scale = _tmp5_;
		_tmp6_ = *alloc;
		draw_width = _tmp6_.width - (draw_x * 2);
		_tmp7_ = *alloc;
		draw_height = _tmp7_.height - draw_y;
		_tmp8_ = self->priv->event_window;
		_tmp9_ = *alloc;
		_tmp10_ = *alloc;
		gdk_window_move_resize (_tmp8_, _tmp9_.x + draw_x, _tmp10_.y + MAX (0, draw_y), draw_width, draw_height);
	}
}

static gboolean
media_button_real_enter_notify_event (GtkWidget* base,
                                      GdkEventCrossing* evt)
{
	MediaButton * self;
	gboolean _tmp0_ = FALSE;
	GdkWindow* _tmp1_;
	GdkWindow* _tmp2_;
	gboolean result = FALSE;
	self = (MediaButton*) base;
	g_return_val_if_fail (evt != NULL, FALSE);
	_tmp1_ = evt->window;
	_tmp2_ = self->priv->event_window;
	if (_tmp1_ == _tmp2_) {
		GdkNotifyType _tmp3_;
		_tmp3_ = evt->detail;
		_tmp0_ = _tmp3_ != GDK_NOTIFY_INFERIOR;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gtk_widget_set_state_flags ((GtkWidget*) self, gtk_widget_get_state_flags ((GtkWidget*) self) | GTK_STATE_FLAG_PRELIGHT, TRUE);
	}
	result = GDK_EVENT_PROPAGATE;
	return result;
}

static gboolean
media_button_real_leave_notify_event (GtkWidget* base,
                                      GdkEventCrossing* evt)
{
	MediaButton * self;
	gboolean _tmp0_ = FALSE;
	GdkWindow* _tmp1_;
	GdkWindow* _tmp2_;
	gboolean result = FALSE;
	self = (MediaButton*) base;
	g_return_val_if_fail (evt != NULL, FALSE);
	_tmp1_ = evt->window;
	_tmp2_ = self->priv->event_window;
	if (_tmp1_ == _tmp2_) {
		GdkNotifyType _tmp3_;
		_tmp3_ = evt->detail;
		_tmp0_ = _tmp3_ != GDK_NOTIFY_INFERIOR;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gtk_widget_set_state_flags ((GtkWidget*) self, gtk_widget_get_state_flags ((GtkWidget*) self) & (~GTK_STATE_FLAG_PRELIGHT), TRUE);
	}
	result = GDK_EVENT_PROPAGATE;
	return result;
}

static GdkEvent*
_vala_GdkEvent_copy (GdkEvent* self)
{
	return g_boxed_copy (gdk_event_get_type (), self);
}

static gpointer
__vala_GdkEvent_copy0 (gpointer self)
{
	return self ? _vala_GdkEvent_copy (self) : NULL;
}

static void
_vala_GdkEvent_free (GdkEvent* self)
{
	g_boxed_free (gdk_event_get_type (), self);
}

static void
_vala_GdkEventSequence_free (GdkEventSequence* self)
{
	g_boxed_free (gdk_event_sequence_get_type (), self);
}

static void
media_button_gesture_pressed_cb (MediaButton* self,
                                 gint n_press,
                                 gdouble x,
                                 gdouble y)
{
	GdkEventSequence* sequence = NULL;
	GtkGestureMultiPress* _tmp0_;
	GdkEventSequence* _tmp1_;
	GdkEvent* event = NULL;
	GtkGestureMultiPress* _tmp2_;
	GdkEventSequence* _tmp3_;
	GdkEvent* _tmp4_;
	GdkEvent* _tmp5_;
	CbMedia* _tmp6_;
	GdkEvent* _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->press_gesture;
	_tmp1_ = gtk_gesture_single_get_current_sequence ((GtkGestureSingle*) _tmp0_);
	sequence = _tmp1_;
	_tmp2_ = self->priv->press_gesture;
	_tmp3_ = sequence;
	_tmp4_ = gtk_gesture_get_last_event ((GtkGesture*) _tmp2_, _tmp3_);
	_tmp5_ = __vala_GdkEvent_copy0 (_tmp4_);
	event = _tmp5_;
	_tmp6_ = self->priv->_media;
	if (_tmp6_ == NULL) {
		__vala_GdkEvent_free0 (event);
		__vala_GdkEventSequence_free0 (sequence);
		return;
	}
	_tmp7_ = event;
	if (gdk_event_triggers_context_menu (_tmp7_)) {
		GtkGestureMultiPress* _tmp8_;
		GtkMenu* _tmp9_;
		GtkMenu* _tmp13_;
		GtkMenu* _tmp14_;
		GdkEvent* _tmp15_;
		_tmp8_ = self->priv->press_gesture;
		gtk_gesture_set_state ((GtkGesture*) _tmp8_, GTK_EVENT_SEQUENCE_CLAIMED);
		_tmp9_ = self->priv->menu;
		if (_tmp9_ == NULL) {
			GMenu* _tmp10_;
			GtkMenu* _tmp11_;
			GtkMenu* _tmp12_;
			_tmp10_ = self->priv->menu_model;
			_tmp11_ = (GtkMenu*) gtk_menu_new_from_model ((GMenuModel*) _tmp10_);
			g_object_ref_sink (_tmp11_);
			_g_object_unref0 (self->priv->menu);
			self->priv->menu = _tmp11_;
			_tmp12_ = self->priv->menu;
			gtk_menu_attach_to_widget (_tmp12_, (GtkWidget*) self, NULL);
		}
		_tmp13_ = self->priv->menu;
		gtk_widget_show_all ((GtkWidget*) _tmp13_);
		_tmp14_ = self->priv->menu;
		_tmp15_ = event;
		gtk_menu_popup_at_pointer (_tmp14_, _tmp15_);
	}
	__vala_GdkEvent_free0 (event);
	__vala_GdkEventSequence_free0 (sequence);
}

static void
media_button_gesture_released_cb (MediaButton* self,
                                  gint n_press,
                                  gdouble x,
                                  gdouble y)
{
	GdkEventSequence* sequence = NULL;
	GtkGestureMultiPress* _tmp0_;
	GdkEventSequence* _tmp1_;
	GdkEvent* event = NULL;
	GtkGestureMultiPress* _tmp2_;
	GdkEventSequence* _tmp3_;
	GdkEvent* _tmp4_;
	GdkEvent* _tmp5_;
	guint button = 0U;
	GtkGestureMultiPress* _tmp6_;
	gboolean _tmp7_ = FALSE;
	CbMedia* _tmp8_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->press_gesture;
	_tmp1_ = gtk_gesture_single_get_current_sequence ((GtkGestureSingle*) _tmp0_);
	sequence = _tmp1_;
	_tmp2_ = self->priv->press_gesture;
	_tmp3_ = sequence;
	_tmp4_ = gtk_gesture_get_last_event ((GtkGesture*) _tmp2_, _tmp3_);
	_tmp5_ = __vala_GdkEvent_copy0 (_tmp4_);
	event = _tmp5_;
	_tmp6_ = self->priv->press_gesture;
	button = gtk_gesture_single_get_current_button ((GtkGestureSingle*) _tmp6_);
	_tmp8_ = self->priv->_media;
	if (_tmp8_ == NULL) {
		_tmp7_ = TRUE;
	} else {
		GdkEvent* _tmp9_;
		_tmp9_ = event;
		_tmp7_ = _tmp9_ == NULL;
	}
	if (_tmp7_) {
		__vala_GdkEvent_free0 (event);
		__vala_GdkEventSequence_free0 (sequence);
		return;
	}
	if (button == ((guint) GDK_BUTTON_PRIMARY)) {
		CbMedia* _tmp10_;
		_tmp10_ = self->priv->_media;
		if (_tmp10_->invalid) {
			media_button_reload_image (self);
		} else {
			GtkGestureMultiPress* _tmp11_;
			gdouble px = 0.0;
			gdouble py = 0.0;
			_tmp11_ = self->priv->press_gesture;
			gtk_gesture_set_state ((GtkGesture*) _tmp11_, GTK_EVENT_SEQUENCE_CLAIMED);
			px = x / ((gdouble) gtk_widget_get_allocated_width ((GtkWidget*) self));
			py = y / ((gdouble) gtk_widget_get_allocated_height ((GtkWidget*) self));
			g_signal_emit (self, media_button_signals[MEDIA_BUTTON_CLICKED_SIGNAL], 0, self, px, py);
		}
	}
	__vala_GdkEvent_free0 (event);
	__vala_GdkEventSequence_free0 (sequence);
}

static gboolean
media_button_real_key_press_event (GtkWidget* base,
                                   GdkEventKey* event)
{
	MediaButton * self;
	gboolean _tmp0_ = FALSE;
	gboolean result = FALSE;
	self = (MediaButton*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	if (event->keyval == GDK_KEY_Return) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = event->keyval == GDK_KEY_KP_Enter;
	}
	if (_tmp0_) {
		CbMedia* _tmp1_;
		_tmp1_ = self->priv->_media;
		if (_tmp1_->invalid) {
			media_button_reload_image (self);
		} else {
			g_signal_emit (self, media_button_signals[MEDIA_BUTTON_CLICKED_SIGNAL], 0, self, 0.5, 0.5);
		}
		result = GDK_EVENT_STOP;
		return result;
	}
	result = GDK_EVENT_PROPAGATE;
	return result;
}

static void
media_button_set_image_description (MediaButton* self)
{
	CbMedia* _tmp0_;
	CbMedia* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = media_button_get_media (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != NULL) {
		CbMedia* _tmp2_;
		CbMedia* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_ = NULL;
		CbMedia* _tmp6_;
		CbMedia* _tmp7_;
		const gchar* _tmp8_;
		AtkObject* _tmp9_;
		_tmp2_ = media_button_get_media (self);
		_tmp3_ = _tmp2_;
		_tmp4_ = _tmp3_->alt_text;
		gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp4_);
		_tmp6_ = media_button_get_media (self);
		_tmp7_ = _tmp6_;
		_tmp8_ = _tmp7_->alt_text;
		_tmp5_ = _tmp8_;
		if (_tmp5_ == NULL) {
			_tmp5_ = "";
		}
		_tmp9_ = gtk_widget_get_accessible ((GtkWidget*) self);
		atk_object_set_description (_tmp9_, _tmp5_);
	}
}

static void
media_button_set_save_as_sensitivity (MediaButton* self)
{
	gboolean _tmp0_ = FALSE;
	CbMedia* _tmp1_;
	GSimpleActionGroup* _tmp4_;
	GAction* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->_media;
	if (!_tmp1_->invalid) {
		gboolean _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = media_button_get_is_m3u8 (self);
		_tmp3_ = _tmp2_;
		_tmp0_ = !_tmp3_;
	} else {
		_tmp0_ = FALSE;
	}
	_tmp4_ = self->priv->actions;
	_tmp5_ = g_action_map_lookup_action ((GActionMap*) _tmp4_, "save-as");
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, g_simple_action_get_type (), GSimpleAction), _tmp0_);
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static gboolean
media_button_get_is_m3u8 (MediaButton* self)
{
	gboolean result;
	CbMedia* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_media;
	_tmp1_ = _tmp0_->url;
	result = string_contains (_tmp1_, ".m3u8");
	return result;
}

CbMedia*
media_button_get_media (MediaButton* self)
{
	CbMedia* result;
	CbMedia* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_media;
	result = _tmp0_;
	return result;
}

void
media_button_set_media (MediaButton* self,
                        CbMedia* value)
{
	CbMedia* _tmp0_;
	CbMedia* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_media;
	if (_tmp0_ != NULL) {
		CbMedia* _tmp1_;
		guint _tmp2_;
		_tmp1_ = self->priv->_media;
		g_signal_parse_name ("progress", CB_TYPE_MEDIA, &_tmp2_, NULL, FALSE);
		g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _media_button_media_progress_cb_cb_media_progress, self);
	}
	_tmp3_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_media);
	self->priv->_media = _tmp3_;
	if (value != NULL) {
		CbMedia* _tmp4_;
		CbMedia* _tmp5_;
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_;
		gboolean _tmp9_;
		_tmp4_ = media_button_get_media (self);
		_tmp5_ = _tmp4_;
		if (!_tmp5_->loaded) {
			CbMedia* _tmp6_;
			_tmp6_ = self->priv->_media;
			g_signal_connect_object (_tmp6_, "progress", (GCallback) _media_button_media_progress_cb_cb_media_progress, self, 0);
		} else {
			self->priv->media_alpha = 1.0;
		}
		media_button_set_save_as_sensitivity (self);
		media_button_set_image_description (self);
		_tmp8_ = media_button_get_is_m3u8 (self);
		_tmp9_ = _tmp8_;
		if (!_tmp9_) {
			CbMedia* _tmp10_;
			_tmp10_ = self->priv->_media;
			_tmp7_ = !cb_media_requires_authentication (_tmp10_);
		} else {
			_tmp7_ = FALSE;
		}
		if (_tmp7_) {
			GMenu* _tmp11_;
			_tmp11_ = self->priv->menu_model;
			g_menu_append (_tmp11_, _ ("Copy URL"), "media.copy-url");
		}
	}
	g_object_notify_by_pspec ((GObject *) self, media_button_properties[MEDIA_BUTTON_MEDIA_PROPERTY]);
}

static void
g_cclosure_user_marshal_VOID__OBJECT_DOUBLE_DOUBLE (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_DOUBLE_DOUBLE) (gpointer data1, gpointer arg_1, gdouble arg_2, gdouble arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_DOUBLE_DOUBLE callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_DOUBLE_DOUBLE) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_double (param_values + 2), g_value_get_double (param_values + 3), data2);
}

static GObject *
media_button_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MediaButton * self;
	parent_class = G_OBJECT_CLASS (media_button_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MEDIA_BUTTON, MediaButton);
	gtk_widget_set_has_window ((GtkWidget*) self, FALSE);
	gtk_widget_set_can_focus ((GtkWidget*) self, TRUE);
	return obj;
}

static void
media_button_class_init (MediaButtonClass * klass,
                         gpointer klass_data)
{
	GError* _inner_error0_ = NULL;
	media_button_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MediaButton_private_offset);
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) media_button_real_draw;
	((GtkWidgetClass *) klass)->get_request_mode = (GtkSizeRequestMode (*) (GtkWidget*)) media_button_real_get_request_mode;
	((GtkWidgetClass *) klass)->get_preferred_height = (void (*) (GtkWidget*, gint*, gint*)) media_button_real_get_preferred_height;
	((GtkWidgetClass *) klass)->get_preferred_height_for_width = (void (*) (GtkWidget*, gint, gint*, gint*)) media_button_real_get_preferred_height_for_width;
	((GtkWidgetClass *) klass)->get_preferred_width_for_height = (void (*) (GtkWidget*, gint, gint*, gint*)) media_button_real_get_preferred_width_for_height;
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget*, gint*, gint*)) media_button_real_get_preferred_width;
	((GtkWidgetClass *) klass)->realize = (void (*) (GtkWidget*)) media_button_real_realize;
	((GtkWidgetClass *) klass)->unrealize = (void (*) (GtkWidget*)) media_button_real_unrealize;
	((GtkWidgetClass *) klass)->map = (void (*) (GtkWidget*)) media_button_real_map;
	((GtkWidgetClass *) klass)->unmap = (void (*) (GtkWidget*)) media_button_real_unmap;
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, GtkAllocation*)) media_button_real_size_allocate;
	((GtkWidgetClass *) klass)->enter_notify_event = (gboolean (*) (GtkWidget*, GdkEventCrossing*)) media_button_real_enter_notify_event;
	((GtkWidgetClass *) klass)->leave_notify_event = (gboolean (*) (GtkWidget*, GdkEventCrossing*)) media_button_real_leave_notify_event;
	((GtkWidgetClass *) klass)->key_press_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) media_button_real_key_press_event;
	G_OBJECT_CLASS (klass)->get_property = _vala_media_button_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_media_button_set_property;
	G_OBJECT_CLASS (klass)->constructor = media_button_constructor;
	G_OBJECT_CLASS (klass)->finalize = media_button_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_BUTTON_MEDIA_PROPERTY, media_button_properties[MEDIA_BUTTON_MEDIA_PROPERTY] = g_param_spec_object ("media", "media", "media", CB_TYPE_MEDIA, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	media_button_signals[MEDIA_BUTTON_CLICKED_SIGNAL] = g_signal_new ("clicked", TYPE_MEDIA_BUTTON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_DOUBLE_DOUBLE, G_TYPE_NONE, 3, TYPE_MEDIA_BUTTON, G_TYPE_DOUBLE, G_TYPE_DOUBLE);
	{
		GdkPixbuf* _tmp0_ = NULL;
		GdkPixbuf* _tmp1_;
		GdkPixbuf* _tmp2_ = NULL;
		GdkPixbuf* _tmp3_;
		cairo_surface_t* _tmp4_;
		cairo_surface_t* _tmp5_;
		cairo_surface_t** _tmp6_;
		_tmp1_ = gdk_pixbuf_new_from_resource ("/uk/co/ibboard/cawbird/data/play.png", &_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp3_ = gdk_pixbuf_new_from_resource ("/uk/co/ibboard/cawbird/data/play@2.png", &_inner_error0_);
		_tmp2_ = _tmp3_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (_tmp0_);
			goto __catch0_g_error;
		}
		_tmp4_ = gdk_cairo_surface_create_from_pixbuf (_tmp0_, 1, NULL);
		_tmp5_ = gdk_cairo_surface_create_from_pixbuf (_tmp2_, 2, NULL);
		_tmp6_ = g_new0 (cairo_surface_t*, 2 + 1);
		_tmp6_[0] = _tmp4_;
		_tmp6_[1] = _tmp5_;
		media_button_play_icons = (_vala_array_free (media_button_play_icons, media_button_play_icons_length1, (GDestroyNotify) cairo_surface_destroy), NULL);
		media_button_play_icons = _tmp6_;
		media_button_play_icons_length1 = 2;
		_media_button_play_icons_size_ = media_button_play_icons_length1;
		_g_object_unref0 (_tmp2_);
		_g_object_unref0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp7_ = e;
		_tmp8_ = _tmp7_->message;
		g_critical ("MediaButton.vala:83: %s", _tmp8_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
	}
}

static void
media_button_instance_init (MediaButton * self,
                            gpointer klass)
{
	self->priv = media_button_get_instance_private (self);
	self->priv->event_window = NULL;
	self->priv->_media = NULL;
	self->priv->menu = NULL;
	self->priv->restrict_height = FALSE;
	self->priv->media_alpha = 0.0;
}

static void
media_button_finalize (GObject * obj)
{
	MediaButton * self;
	CbMedia* _tmp0_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MEDIA_BUTTON, MediaButton);
	_tmp0_ = self->priv->_media;
	if (_tmp0_ != NULL) {
		CbMedia* _tmp1_;
		guint _tmp2_;
		_tmp1_ = self->priv->_media;
		g_signal_parse_name ("progress", CB_TYPE_MEDIA, &_tmp2_, NULL, FALSE);
		g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _media_button_media_progress_cb_cb_media_progress, self);
	}
	_g_object_unref0 (self->priv->event_window);
	_g_object_unref0 (self->priv->_media);
	_g_object_unref0 (self->priv->menu_model);
	_g_object_unref0 (self->priv->menu);
	_g_object_unref0 (self->priv->actions);
	_g_object_unref0 (self->priv->layout);
	_g_object_unref0 (self->priv->press_gesture);
	G_OBJECT_CLASS (media_button_parent_class)->finalize (obj);
}

static GType
media_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MediaButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) media_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MediaButton), 0, (GInstanceInitFunc) media_button_instance_init, NULL };
	GType media_button_type_id;
	media_button_type_id = g_type_register_static (gtk_bin_get_type (), "MediaButton", &g_define_type_info, 0);
	MediaButton_private_offset = g_type_add_instance_private (media_button_type_id, sizeof (MediaButtonPrivate));
	return media_button_type_id;
}

GType
media_button_get_type (void)
{
	static volatile gsize media_button_type_id__volatile = 0;
	if (g_once_init_enter (&media_button_type_id__volatile)) {
		GType media_button_type_id;
		media_button_type_id = media_button_get_type_once ();
		g_once_init_leave (&media_button_type_id__volatile, media_button_type_id);
	}
	return media_button_type_id__volatile;
}

static void
_vala_media_button_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	MediaButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MEDIA_BUTTON, MediaButton);
	switch (property_id) {
		case MEDIA_BUTTON_MEDIA_PROPERTY:
		g_value_set_object (value, media_button_get_media (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_media_button_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	MediaButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MEDIA_BUTTON, MediaButton);
	switch (property_id) {
		case MEDIA_BUTTON_MEDIA_PROPERTY:
		media_button_set_media (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

